/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "MsgBox.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Compressor.bi"
#Include Once "Resource.bi"

Function CompressorDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4028", "Compressor" ), _
				GetTranslateString( "4029", "Choose the compressor to be used for the installer." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Add compressors
			SendDlgItemMessage( hWin, IDC_CBOCOMPRESSOR, CB_ADDSTRING, NULL, Cast( LPARAM, @"LZMA" ) )
			SendDlgItemMessage( hWin, IDC_CBOCOMPRESSOR, CB_ADDSTRING, NULL, Cast( LPARAM, @"ZLib" ) )
			SendDlgItemMessage( hWin, IDC_CBOCOMPRESSOR, CB_ADDSTRING, NULL, Cast( LPARAM, @"BZip2" ) )

			' Set compressor
			SendDlgItemMessage( hWin, IDC_CBOCOMPRESSOR, CB_SETCURSEL, ProjectSettings.Compressor, NULL )

			' Set compressor options
			If (ProjectSettings.CompressorOptions And PROJPUB_COMPRESSOR_SOLID) <> NULL Then
				CheckDlgButton( hWin, IDC_CHKCOMPRESSORSOLID, BST_CHECKED )
			End If

			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If GlobalSettings.ShowCompressorPage = 0 Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					'
				Case PSN_WIZNEXT
					ProjectSettings.Compressor = SendDlgItemMessage( hWin, IDC_CBOCOMPRESSOR, CB_GETCURSEL, NULL, NULL )
					If IsDlgButtonChecked( hWin, IDC_CHKCOMPRESSORSOLID ) = BST_CHECKED Then
						ProjectSettings.CompressorOptions Or= PROJPUB_COMPRESSOR_SOLID
					Else
						ProjectSettings.CompressorOptions And= Not PROJPUB_COMPRESSOR_SOLID
					End If
					If ProjectSettings.Compressor = CB_ERR Then
						ErrorBox( hWin, GetTranslateString( "5008", "No compressor is selected." ) )
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return -1
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

