/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "ProjType.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Hooks.bi"
#Include Once "FileAssoc.bi"
#Include Once "Resource.bi"

Function FileAssocDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static FileTypeIsChanging As BOOL = FALSE

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4022", "File Association" ), _
				GetTranslateString( "4023", "Choose the file types to associate with your application." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			Dim EDTAppIdKey As HWND = GetDlgItem( hWin, IDC_EDTFILEASSOCAPPID )
			CreateHook( EDTAppIdKey, @KeyNameEditHook )

			' Show file types (if any)
			ShowFileTypes( GetDlgItem( hWin, IDC_LSTFILEASSOC ), @ProjectSettings.FileAssociations )
			SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTFILEASSOC, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTFILEASSOC ) ) )
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case EN_CHANGE
					Select Case LoWord( wParam )
						Case IDC_EDTFILEASSOCFILEEXT
							If FileTypeIsChanging <> TRUE Then
								Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
								If FileTypeId >= 0 Then
									GetDlgItemText( hWin, IDC_EDTFILEASSOCFILEEXT, @buffer, MAX_PATH )
									SetNewFileTypeExt( @ProjectSettings.FileAssociations, FileTypeId, buffer )
									SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_DELETESTRING, Cast( WPARAM, FileTypeId ), NULL )
									SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_INSERTSTRING, Cast( WPARAM, FileTypeId ), Cast( LPARAM, @buffer ) )
									SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_SETCURSEL, Cast( WPARAM, FileTypeId ), NULL )
								End If
							End If
							'
						Case IDC_EDTFILEASSOCAPPID
							If FileTypeIsChanging <> TRUE Then
								Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
								If FileTypeId >= 0 Then
									GetDlgItemText( hWin, IDC_EDTFILEASSOCAPPID, @buffer, MAX_PATH )
									SetNewFileTypeAppIdKey( @ProjectSettings.FileAssociations, FileTypeId, buffer )
								End If
							End If
							'
						Case IDC_EDTFILEASSOCDESC
							If FileTypeIsChanging <> TRUE Then
								Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
								If FileTypeId >= 0 Then
									GetDlgItemText( hWin, IDC_EDTFILEASSOCDESC, @buffer, MAX_PATH )
									SetNewFileTypeDescription( @ProjectSettings.FileAssociations, FileTypeId, buffer )
								End If
							End If
							'
						Case IDC_EDTFILEASSOCDEFICON
							If FileTypeIsChanging <> TRUE Then
								Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
								If FileTypeId >= 0 Then
									GetDlgItemText( hWin, IDC_EDTFILEASSOCDEFICON, @buffer, MAX_PATH )
									SetNewFileTypeDefaultIcon( @ProjectSettings.FileAssociations, FileTypeId, buffer )
								End If
							End If
							'
					End Select
					'
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDC_BTNFILEASSOCADD
							InsertFileTypeToEnd( @ProjectSettings.FileAssociations, ".ext", "", "", "" )
							Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_ADDSTRING, 0, Cast( LPARAM, @".ext" ) )
							SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_SETCURSEL, FileTypeId, NULL )
							SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTFILEASSOC, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTFILEASSOC ) ) )
							'
						Case IDC_BTNFILEASSOCREMOVE
							Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
							If FileTypeId >= 0 Then
								RemoveFileType( @ProjectSettings.FileAssociations, FileTypeId )
								SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_DELETESTRING, Cast( WPARAM, FileTypeId ), NULL ) - 1, NULL )
								SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTFILEASSOC, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTFILEASSOC ) ) )
							End If
							'
						Case IDC_BTNFILEASSOCEDITMENUITEMS
							Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
							If FileTypeId >= 0 Then
								DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_DLGMENUITEMS ), hWin, @ContextMenuItemsDialogProc, Cast( LPARAM, FileTypeId ) )
							End If
							'
					End Select
				Case LBN_SELCHANGE
					Select Case LoWord( wParam )
						Case IDC_LSTFILEASSOC
							FileTypeIsChanging = TRUE
							Dim FileTypeId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILEASSOC, LB_GETCURSEL, NULL, NULL )
							ShowFileTypeDetails( hWin, @ProjectSettings.FileAssociations, FileTypeId )
							FileTypeIsChanging = FALSE
							'
					End Select
					'
			End Select
			Return 0
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GAME Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_RAADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_MEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

Function ContextMenuItemsDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static FileTypeIdOfContextMenus As Integer
	Static ContextMenuItemIsChanging As BOOL = FALSE

	Select Case uMsg
		Case WM_INITDIALOG
			buffer = """" & ProjectSettings.MainProgram & """ ""%1"""
			SendDlgItemMessage( hWin, IDC_CBOMENUITEMSVERB, CB_ADDSTRING, NULL, Cast( LPARAM, @"open" ) )
			SendDlgItemMessage( hWin, IDC_CBOMENUITEMSVERB, CB_ADDSTRING, NULL, Cast( LPARAM, @"print" ) )
			SendDlgItemMessage( hWin, IDC_CBOMENUITEMSVERB, CB_ADDSTRING, NULL, Cast( LPARAM, @"printto" ) )
			SendDlgItemMessage( hWin, IDC_CBOMENUITEMSCMD, CB_ADDSTRING, NULL, Cast( LPARAM, @buffer ) )

			' Get FileTypeId
			FileTypeIdOfContextMenus = lParam

			Dim CBOVerb As HWND = ChildWindowFromPoint( GetDlgItem( hWin, IDC_CBOMENUITEMSVERB ), Type <Point> ( 5, 5 ) )
			CreateHook( CBOVerb, @KeyNameEditHook )

			' Show context menu items, if any
			ShowContextMenuItems( GetDlgItem( hWin, IDC_LSTMENUITEMS ), GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ) )
			SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTMENUITEMS, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTMENUITEMS ) ) )
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case CBN_EDITCHANGE
					Select Case LoWord( wParam )
						Case IDC_CBOMENUITEMSVERB
							If ContextMenuItemIsChanging <> TRUE Then
								Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
								If ContextMenuId >= 0 Then
									GetDlgItemText( hWin, IDC_CBOMENUITEMSVERB, @buffer, MAX_PATH )
									SetNewFileTypeContextMenuVerb( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId, buffer )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_DELETESTRING, Cast( WPARAM, ContextMenuId ), NULL )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_INSERTSTRING, Cast( WPARAM, ContextMenuId ), Cast( LPARAM, @buffer ) )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_SETCURSEL, Cast( WPARAM, ContextMenuId ), NULL )
								End If
							End If
							'
						Case IDC_CBOMENUITEMSCMD
							If ContextMenuItemIsChanging <> TRUE Then
								Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
								If ContextMenuId >= 0 Then
									GetDlgItemText( hWin, IDC_CBOMENUITEMSCMD, @buffer, MAX_PATH )
									SetNewFileTypeContextMenuCommand( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId, buffer )
								End If
							End If
							'
					End Select
					'
				Case CBN_SELCHANGE, LBN_SELCHANGE	' Same values
					Select Case LoWord( wParam )
						Case IDC_CBOMENUITEMSVERB
							If ContextMenuItemIsChanging <> TRUE Then
								Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
								If ContextMenuId >= 0 Then
									Dim CurSel As Integer = SendDlgItemMessage( hWin, IDC_CBOMENUITEMSVERB, CB_GETCURSEL, NULL, NULL )
									SendDlgItemMessage( hWin, IDC_CBOMENUITEMSVERB, CB_GETLBTEXT, CurSel, Cast( LPARAM, @buffer ) )
									SetNewFileTypeContextMenuVerb( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId, buffer )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_DELETESTRING, Cast( WPARAM, ContextMenuId ), NULL )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_INSERTSTRING, Cast( WPARAM, ContextMenuId ), Cast( LPARAM, @buffer ) )
									SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_SETCURSEL, Cast( WPARAM, ContextMenuId ), NULL )
								End If
							End If
							'
						Case IDC_CBOMENUITEMSCMD
							If ContextMenuItemIsChanging <> TRUE Then
								Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
								If ContextMenuId >= 0 Then
									Dim CurSel As Integer = SendDlgItemMessage( hWin, IDC_CBOMENUITEMSCMD, CB_GETCURSEL, NULL, NULL )
									SendDlgItemMessage( hWin, IDC_CBOMENUITEMSCMD, CB_GETLBTEXT, CurSel, Cast( LPARAM, @buffer ) )
									SetNewFileTypeContextMenuCommand( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId, buffer )
								End If
							End If
							'
						Case IDC_LSTMENUITEMS
							ContextMenuItemIsChanging = TRUE
							Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
							ShowFileTypeContextMenuDetails( hWin, GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId )
							ContextMenuItemIsChanging = FALSE
							'
					End Select
					'
				Case EN_CHANGE
					Select Case LoWord( wParam )
						Case IDC_EDTMENUITEMSTITLE
							If ContextMenuItemIsChanging <> TRUE Then
								Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
								If ContextMenuId >= 0 Then
									GetDlgItemText( hWin, IDC_EDTMENUITEMSTITLE, @buffer, MAX_PATH )
									SetNewFileTypeContextMenuItemText( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId, buffer )
								End If
							End If
							'
					End Select
					'
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDOK
							EndDialog( hWin, NULL )
							'
						Case IDC_BTNMENUITEMSADD
							InsertFileTypeContextMenuToFileTypeToEnd( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), "open", "", "" )
							Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_ADDSTRING, 0, Cast( LPARAM, @"open" ) )
							SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_SETCURSEL, ContextMenuId, NULL )
							SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTMENUITEMS, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTMENUITEMS ) ) )
							'
						Case IDC_BTNMENUITEMSREMOVE
							Dim ContextMenuId As Integer = SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_GETCURSEL, NULL, NULL )
							If ContextMenuId >= 0 Then
								RemoveFileTypeContextMenuInFileType( GetFileType_( @ProjectSettings.FileAssociations, FileTypeIdOfContextMenus ), ContextMenuId )
								SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTMENUITEMS, LB_DELETESTRING, Cast( WPARAM, ContextMenuId ), NULL ) - 1, NULL )
								SendMessage( hWin, WM_COMMAND, MAKEWPARAM( IDC_LSTMENUITEMS, LBN_SELCHANGE ), Cast( LPARAM, GetDlgItem( hWin, IDC_LSTMENUITEMS ) ) )
							End If
							'
					End Select
			End Select
			Return 0
			'
		Case WM_CLOSE
			EndDialog( hWin, NULL )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

Sub ShowFileTypes( _
	ByVal ListBoxFileTypeCtrl As HWND, _
	ByVal Head As ProjPub_FileType Ptr _
	)

	SendMessage( ListBoxFileTypeCtrl, LB_RESETCONTENT, NULL, NULL )

	Dim CurFileType As ProjPub_FileType Ptr = Head->Next

	Do While CurFileType <> NULL
		SendMessage( ListBoxFileTypeCtrl, LB_ADDSTRING, NULL, Cast( LPARAM, CurFileType->Ext ) )
		CurFileType = CurFileType->Next
	Loop

	SendMessage( ListBoxFileTypeCtrl, LB_SETCURSEL, SendMessage( ListBoxFileTypeCtrl, LB_GETCOUNT, NULL, NULL ) - 1, NULL )

End Sub

Sub ShowFileTypeDetails( _
	ByVal hWin As HWND, _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal FileTypeId As Integer _
	)

	Dim CurFileType As ProjPub_FileType Ptr = GetFileType_( Head, FileTypeId )

	SetDlgItemText( hWin, IDC_EDTFILEASSOCFILEEXT, CurFileType->Ext )
	SetDlgItemText( hWin, IDC_EDTFILEASSOCAPPID, CurFileType->AppIDKey )
	SetDlgItemText( hWin, IDC_EDTFILEASSOCDESC, CurFileType->Description )
	SetDlgItemText( hWin, IDC_EDTFILEASSOCDEFICON, CurFileType->DefaultIcon )	

End Sub

Sub ShowContextMenuItems( _
	ByVal ListBoxContextMenuItemsCtrl As HWND, _
	ByVal FileType As ProjPub_FileType Ptr _
	)

	SendMessage( ListBoxContextMenuItemsCtrl, LB_RESETCONTENT, NULL, NULL )

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = (@(FileType->ContextMenu))->Next

	Do While CurFileTypeContextMenu <> NULL
		SendMessage( ListBoxContextMenuItemsCtrl, LB_ADDSTRING, NULL, Cast( LPARAM, CurFileTypeContextMenu->Verb ) )
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Loop

	SendMessage( ListBoxContextMenuItemsCtrl, LB_SETCURSEL, SendMessage( ListBoxContextMenuItemsCtrl, LB_GETCOUNT, NULL, NULL ) - 1, NULL )

End Sub

Sub ShowFileTypeContextMenuDetails( _
	ByVal hWin As HWND, _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal FileTypeContextMenuId As Integer _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To FileTypeContextMenuId
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Next

	SetDlgItemText( hWin, IDC_CBOMENUITEMSVERB, CurFileTypeContextMenu->Verb )
	SetDlgItemText( hWin, IDC_EDTMENUITEMSTITLE, CurFileTypeContextMenu->ItemText )
	SetDlgItemText( hWin, IDC_CBOMENUITEMSCMD, CurFileTypeContextMenu->Command )

End Sub

Sub RemoveFileType( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal id As Integer _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head
	Dim PrevFileType As ProjPub_FileType Ptr

	For i As Integer = 0 To id
		If CurFileType = NULL Then Return
		PrevFileType = CurFileType
		CurFileType = CurFileType->Next
	Next

	PrevFileType->Next=CurFileType->Next
	Delete[] CurFileType->Ext
	Delete[] CurFileType->AppIDKey
	Delete[] CurFileType->Description
	Delete[] CurFileType->DefaultIcon
	RemoveAllFileTypeContextMenusInFileType( CurFileType )
	Delete CurFileType

End Sub

Sub RemoveAllFileTypes( _
	ByVal Head As ProjPub_FileType Ptr _
	)

	Dim NextFileType As ProjPub_FileType Ptr

	Do While Head->Next <> NULL
		NextFileType=Head->Next->Next
		Delete[] Head->Next->Ext
		Delete[] Head->Next->AppIDKey
		Delete[] Head->Next->Description
		Delete[] Head->Next->DefaultIcon
		RemoveAllFileTypeContextMenusInFileType( Head->Next )
		Delete Head->Next
		Head->Next=NextFileType
	Loop

End Sub

Function GetFileTypesNum( _
	ByVal Head As ProjPub_FileType Ptr _
	) As Integer

	Dim CurFileType As ProjPub_FileType Ptr = Head->Next
	Dim Num As Integer

	Do While CurFileType <> NULL
		CurFileType = CurFileType->Next
		Num += 1
	Loop

	Return Num

End Function

Sub InsertFileTypeToEnd( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByRef FileTypeExt As Const String, _
	ByRef FileTypeAppIDKey As Const String, _
	ByRef FileTypeDescription As Const String, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	Do While CurFileType->Next <> NULL
		CurFileType = CurFileType->Next
	Loop

	CurFileType->Next = New ProjPub_FileType
	CurFileType->Next->Ext = New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Next->Ext = FileTypeExt
	CurFileType->Next->AppIDKey = New Byte [Len( FileTypeAppIDKey ) + 1]
	*CurFileType->Next->AppIDKey = FileTypeAppIDKey
	CurFileType->Next->Description = New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Next->Description = FileTypeDescription
	CurFileType->Next->DefaultIcon = New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->Next->DefaultIcon = FileTypeDefaultIcon
	CurFileType->Next->Next = NULL

End Sub


Sub InsertFileType( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeExt As Const String, _
	ByRef FileTypeAppIDKey As Const String, _
	ByRef FileTypeDescription As Const String, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head
	Dim TempFileType As ProjPub_FileType Ptr
	Dim CurFileTypeId As Integer = 0

	Do Until CurFileTypeId = Id
		If CurFileType->Next <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
		CurFileTypeId += 1
	Loop

	TempFileType=CurFileType->Next
	CurFileType->Next=New ProjPub_FileType
	CurFileType->Next->Ext = New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Next->Ext = FileTypeExt
	CurFileType->Next->AppIDKey = New Byte [Len( FileTypeAppIDKey ) + 1]
	*CurFileType->Next->AppIDKey = FileTypeAppIDKey
	CurFileType->Next->Description = New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Next->Description = FileTypeDescription
	CurFileType->Next->DefaultIcon = New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->Next->DefaultIcon = FileTypeDefaultIcon
	CurFileType->Next->Next=TempFileType

End Sub
'/


Sub ReverseFileTypes( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFileType As ProjPub_FileType Ptr = Head
	Dim CurFileType As ProjPub_FileType Ptr
	Dim NextFileType As ProjPub_FileType Ptr
	Dim TempFileType As ProjPub_FileType Ptr

	If Id+1>=GetFileTypesNum( Head ) Then Return
	For i As Integer = 0 To Id-1
		PrevFileType = PrevFileType->Next
	Next

	CurFileType=PrevFileType->Next
	NextFileType=CurFileType->Next
	TempFileType=PrevFileType->Next
	PrevFileType->Next=CurFileType->Next
	CurFileType->Next=NextFileType->Next
	NextFileType->Next=TempFileType
	
End Sub
'/


Sub SetNewFileTypeExt( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeExt As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->Ext
	CurFileType->Ext=New Byte [Len( FileTypeExt ) + 1]
	*CurFileType->Ext=FileTypeExt

End Sub


Sub SetNewFileTypeAppIdKey( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeAppIdKey As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->AppIdKey
	CurFileType->AppIdKey=New Byte [Len( FileTypeAppIdKey ) + 1]
	*CurFileType->AppIdKey=FileTypeAppIdKey

End Sub

Sub SetNewFileTypeDescription( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeDescription As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->Description
	CurFileType->Description=New Byte [Len( FileTypeDescription ) + 1]
	*CurFileType->Description=FileTypeDescription

End Sub

Sub SetNewFileTypeDefaultIcon( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeDefaultIcon As Const String _
	)

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileType->DefaultIcon
	CurFileType->DefaultIcon=New Byte [Len( FileTypeDefaultIcon ) + 1]
	*CurFileType->DefaultIcon=FileTypeDefaultIcon

End Sub

'/

Function GetFileType_( _
	ByVal Head As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	) As ProjPub_FileType Ptr

	Dim CurFileType As ProjPub_FileType Ptr = Head

	For i As Integer = 0 To id
		If CurFileType <> NULL Then
			CurFileType = CurFileType->Next
		Else
			Return NULL
		End If
	Next

	Return CurFileType

End Function

Sub RemoveFileTypeContextMenuInFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal id As Integer _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim PrevFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	For i As Integer = 0 To id
		If CurFileTypeContextMenu = NULL Then Return
		PrevFileTypeContextMenu = CurFileTypeContextMenu
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Next

	PrevFileTypeContextMenu->Next=CurFileTypeContextMenu->Next
	Delete[] CurFileTypeContextMenu->Verb
	Delete[] CurFileTypeContextMenu->ItemText
	Delete[] CurFileTypeContextMenu->Command
	Delete CurFileTypeContextMenu

End Sub

Sub RemoveAllFileTypeContextMenusInFileType( _
	ByVal FileType As ProjPub_FileType Ptr _
	)

	Dim NextFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	Do While (@FileType->ContextMenu)->Next <> NULL
		NextFileTypeContextMenu=(@FileType->ContextMenu)->Next->Next
		Delete[] (@FileType->ContextMenu)->Next->Verb
		Delete[] (@FileType->ContextMenu)->Next->ItemText
		Delete[] (@FileType->ContextMenu)->Next->Command
		Delete (@FileType->ContextMenu)->Next
		(@FileType->ContextMenu)->Next=NextFileTypeContextMenu
	Loop

End Sub

Sub InsertFileTypeContextMenuToFileTypeToEnd( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByRef FileTypeContextMenuVerb As Const String, _
	ByRef FileTypeContextMenuItemText As Const String, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	Do While CurFileTypeContextMenu->Next <> NULL
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
	Loop

	CurFileTypeContextMenu->Next = New ProjPub_FileTypeContextMenu
	CurFileTypeContextMenu->Next->Verb = New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Next->Verb = FileTypeContextMenuVerb
	CurFileTypeContextMenu->Next->ItemText = New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->Next->ItemText = FileTypeContextMenuItemText
	CurFileTypeContextMenu->Next->Command = New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Next->Command = FileTypeContextMenuCommand
	CurFileTypeContextMenu->Next->Next = NULL

End Sub


Sub InsertFileTypeContextMenuToFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuVerb As Const String, _
	ByRef FileTypeContextMenuItemText As Const String, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim TempFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim CurFileTypeContextMenuId As Integer = 0

	Do Until CurFileTypeContextMenuId = Id
		If CurFileTypeContextMenu->Next <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
		CurFileTypeContextMenuId += 1
	Loop

	TempFileTypeContextMenu=CurFileTypeContextMenu->Next
	CurFileTypeContextMenu->Next=New ProjPub_FileTypeContextMenu
	CurFileTypeContextMenu->Next->Verb = New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Next->Verb = FileTypeContextMenuVerb
	CurFileTypeContextMenu->Next->ItemText = New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->Next->ItemText = FileTypeContextMenuItemText
	CurFileTypeContextMenu->Next->Command = New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Next->Command = FileTypeContextMenuCommand
	CurFileTypeContextMenu->Next->Next=TempFileTypeContextMenu

End Sub

Function GetFileTypeContextMenusInFileTypeNum( _
	ByVal FileType As ProjPub_FileType Ptr _
	) As Integer

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = (@FileType->ContextMenu)->Next
	Dim Num As Integer

	Do While CurFileTypeContextMenu <> NULL
		CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Num += 1
	Loop

	Return Num

End Function

Sub ReverseFileTypeContextMenusInFileType( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu
	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim NextFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr
	Dim TempFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr

	If Id+1>=GetFileTypeContextMenusInFileTypeNum( FileType ) Then Return
	For i As Integer = 0 To Id-1
		PrevFileTypeContextMenu = PrevFileTypeContextMenu->Next
	Next

	CurFileTypeContextMenu=PrevFileTypeContextMenu->Next
	NextFileTypeContextMenu=CurFileTypeContextMenu->Next
	TempFileTypeContextMenu=PrevFileTypeContextMenu->Next
	PrevFileTypeContextMenu->Next=CurFileTypeContextMenu->Next
	CurFileTypeContextMenu->Next=NextFileTypeContextMenu->Next
	NextFileTypeContextMenu->Next=TempFileTypeContextMenu
	
End Sub


Sub SetNewFileTypeContextMenuVerb( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuVerb As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->Verb
	CurFileTypeContextMenu->Verb=New Byte [Len( FileTypeContextMenuVerb ) + 1]
	*CurFileTypeContextMenu->Verb=FileTypeContextMenuVerb

End Sub

Sub SetNewFileTypeContextMenuItemText( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuItemText As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->ItemText
	CurFileTypeContextMenu->ItemText=New Byte [Len( FileTypeContextMenuItemText ) + 1]
	*CurFileTypeContextMenu->ItemText=FileTypeContextMenuItemText

End Sub

Sub SetNewFileTypeContextMenuCommand( _
	ByVal FileType As ProjPub_FileType Ptr, _
	ByVal Id As Integer, _
	ByRef FileTypeContextMenuCommand As Const String _
	)

	Dim CurFileTypeContextMenu As ProjPub_FileTypeContextMenu Ptr = @FileType->ContextMenu

	For i As Integer = 0 To id
		If CurFileTypeContextMenu <> NULL Then
			CurFileTypeContextMenu = CurFileTypeContextMenu->Next
		Else
			Return
		End If
	Next

	Delete[] CurFileTypeContextMenu->Command
	CurFileTypeContextMenu->Command=New Byte [Len( FileTypeContextMenuCommand ) + 1]
	*CurFileTypeContextMenu->Command=FileTypeContextMenuCommand

End Sub

