/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "FileFuncs.bi"


Function GetDir( _
	ByRef Path As Const String _
	) As String

	Return Left( Path, InStrRev( Path, "\" ) - 1 )

End Function


Function GetFileName( _
	ByRef Path As Const String _
	) As String

	Return Mid( Path, InStrRev( Path, "\" ) + 1 )

End Function


Function GetBaseName( _
	ByRef Path As Const String _
	) As String

	Dim FileName As String = GetFileName( Path )

	Return Left( FileName, InStrRev( FileName, "." ) - 1 )

End Function

/'
Function GetUpFromParentDir( _
	ByRef Path As Const String _
	) As Integer

	Dim TempPath As String = Path

	Dim BackslashPos As Integer = InStr( TempPath, "\" )
	Dim BackslashNum As Integer
	
	Do While BackslashPos
		TempPath = Mid( TempPath, BackslashPos + 1 )
		BackslashNum += 1
		BackslashPos = InStr( TempPath, "\" )
	Loop
	
	Return BackslashNum

End Function
'/

Function GetRelativePath( _
	ByVal AbsolutePath As Const String, _
	ByVal Folder As Const String _
	) As String

	Dim PrependPath As String
	Dim TempFolder As String = Folder

	Do
		If UCase( Left( AbsolutePath, Len( TempFolder ) + 1 ) ) = UCase( TempFolder & "\" ) Then
			Return PrependPath & Mid( AbsolutePath, Len( TempFolder ) + 2 )
		Else
			PrependPath &= "..\"
			TempFolder = Left( TempFolder, InStrRev( TempFolder, "\" ) - 1 )
			' Check if string is empty or equal to drive (i.e. "C:")
			If TempFolder = "" Or TempFolder = Left( Folder, 2 ) Then
				Return AbsolutePath
			End If
		End If
	Loop

End Function

