/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/commdlg.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "ProjType.bi"
#Include Once "Settings.bi"
#Include Once "FileFuncs.bi"
#Include Once "MsgBox.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Hooks.bi"
#Include Once "Files.bi"
#Include Once "Resource.bi"

Function FilesDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4012", "Files" ), _
				GetTranslateString( "4013", "Choose the files you want to be installed with your application." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Show folders (if any)
			ShowFolders( GetDlgItem( hWin, IDC_LSTFILESFOLDERS ), GetDlgItem( hWin, IDC_LSTFILESFILES ), @ProjectSettings.Folders )

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTFILESMAIN, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Set defaults
			SetDlgItemText( hWin, IDC_EDTFILESMAIN, @ProjectSettings.MainProgram )
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case LBN_SELCHANGE
					Select Case LoWord( wParam )
						Case IDC_LSTFILESFOLDERS
							Dim FolderId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL )
							If FolderId >= 0 Then ShowFolderContents( GetDlgItem( hWin, IDC_LSTFILESFILES ), @ProjectSettings.Folders, FolderId ) 
							'
					End Select
					'
				Case Else
					Select Case LoWord( wParam )
						Case IDC_BTNFILESFOLDERSADD, IDC_BTNFILESFOLDERSADDSUBDIR
							Dim FolderName As ZString Ptr
							If SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCOUNT, NULL, NULL ) = 0 Then
								buffer = "$INSTDIR"
								FolderName = Cast( ZString Ptr, DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_DLGFOLDERNAME ), hWin, @FolderNameDialogProc, Cast( LPARAM, @buffer ) ) )
							ElseIf LoWord( wParam ) = IDC_BTNFILESFOLDERSADDSUBDIR Then
								SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETTEXT, SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL ), Cast( LPARAM, @buffer ) )
								buffer += "\"
								FolderName = Cast( ZString Ptr, DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_DLGFOLDERNAME ), hWin, @FolderNameDialogProc, Cast( LPARAM, @buffer ) ) )
							Else
								FolderName = Cast( ZString Ptr, DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_DLGFOLDERNAME ), hWin, @FolderNameDialogProc, NULL ) )
							End If
							If FolderName Then
								InsertFolderToEnd( @ProjectSettings.Folders, *FolderName )
								SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_ADDSTRING, 0, Cast( LPARAM, FolderName ) ), NULL )
								SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_RESETCONTENT, NULL, NULL )
							End If
							'
						Case IDC_BTNFILESFOLDERSREMOVE
							Dim FolderId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL )
							If FolderId >= 0 Then
								RemoveFolder( @ProjectSettings.Folders, FolderId )
								SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_DELETESTRING, FolderId, 0 ) - 1, NULL )
							End If
							'
						Case IDC_BTNFILESFILESADD
							Dim FolderId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL )
							If FolderId >= 0 Then

								Dim ofn As OPENFILENAME
								Dim buff As ZString * MAX_PATH+1
								Dim OpenDlgTitle As String = GetTranslateString( "6002", "Select File To Include" )
							
								With ofn
									.lStructSize = SizeOf(OPENFILENAME)
									.hwndOwner = hWin
									.hInstance = hInstance
									.lpstrInitialDir = @CurProjectPath
									.lpstrFile = @buff
									.nMaxFile = MAX_PATH
									.lpstrFilter = @!"All Files (*.*)\0*.*\0"
									.lpstrTitle = StrPtr( OpenDlgTitle )
									.Flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER Or OFN_ALLOWMULTISELECT
								End With

								If GetOpenFileName( @ofn ) Then
									Dim FolderName As String = buff
									Dim CurFileName As String
									Dim CurFileNameLength As Integer
									' Check if FolderName is a directory
									If (GetFileAttributes( FolderName ) And FILE_ATTRIBUTE_DIRECTORY) <> NULL Then
										Do Until *( @buff + ofn.nFileOffset + CurFileNameLength ) = NULL
											' Get file name
											CurFileName = *Cast( ZString Ptr, @buff + ofn.nFileOffset + CurFileNameLength)
											' Get length to find the next file
											CurFileNameLength += Len( CurFileName ) + 1
											' Get relative path of file and add file to list
											CurFileName = GetRelativePath( FolderName & "\"& CurFileName, CurProjectPath )
											InsertFileToFolderToEnd( GetFolder( @ProjectSettings.Folders, FolderId), CurFileName )
											SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_ADDSTRING, 0, Cast( LPARAM, StrPtr( CurFileName ) ) ) , NULL )
										Loop
									Else
										' Only one selection, and it is a file
										CurFileName = GetRelativePath( FolderName, CurProjectPath )
										InsertFileToFolderToEnd( GetFolder( @ProjectSettings.Folders, FolderId), CurFileName )
										SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_ADDSTRING, 0, Cast( LPARAM, StrPtr( CurFileName ) ) ) , NULL )
									End If
								End If
							End If
							'
						Case IDC_BTNFILESFILESREMOVE
							Dim FolderId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL )
							Dim FileId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_GETCURSEL, NULL, NULL )
							If FolderId >= 0 And FileId >= 0 Then
								RemoveFileInFolder( GetFolder( @ProjectSettings.Folders, FolderId ), FileId )
								SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_DELETESTRING, FileId, 0 ) - 1, NULL )
							End If
							'
						Case IDC_BTNFILESMAIN
							Dim MainProgramFile As ZString Ptr = Cast( ZString Ptr, DialogBoxParam( hInstance, MAKEINTRESOURCE( IDD_DLGSELMAINEXE ), hWin, @SelectMainDialogProc, Cast( LPARAM, @ProjectSettings.Folders ) ) )
							If MainProgramFile Then
								SetDlgItemText( hWin, IDC_EDTFILESMAIN, MainProgramFile )
							End If
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_RAADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_MEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						EnableDlgItem( hWin, IDC_EDTFILESMAIN, FALSE )
						EnableDlgItem( hWin, IDC_BTNFILESMAIN, FALSE )
					Else
						EnableDlgItem( hWin, IDC_EDTFILESMAIN, TRUE )
						EnableDlgItem( hWin, IDC_BTNFILESMAIN, TRUE )
					End If
					'
				Case PSN_WIZNEXT
					GetDlgItemText( hWin, IDC_EDTFILESMAIN, @ProjectSettings.MainProgram, MAX_PATH )
					If ProjectSettings.MainProgram = "" And _
						Not (ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
							ProjectSettings.ProjectType = PROJPUB_PROJTYPE_RAADDIN Or _
							ProjectSettings.ProjectType = PROJPUB_PROJTYPE_MEADDIN Or _
							ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN) Then
						ErrorBox( hWin, GetTranslateString( "5004", "Main program is not selected." ) )
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return -1
					End If
					'
			End Select
			'
		Case WM_DROPFILES
			Dim FolderId As Integer = SendDlgItemMessage( hWin, IDC_LSTFILESFOLDERS, LB_GETCURSEL, NULL, NULL )

			If FolderId >= 0 Then

				' Get number of files
				Dim FileCount As Integer = DragQueryFile( Cast( HDROP, wParam ), &hFFFFFFFF, NULL, NULL )
	
				' Add files to list box
				For i As Integer = 0 To FileCount-1
					DragQueryFile( Cast( HDROP, wParam ), i, @buffer, MAX_PATH )
					If (GetFileAttributes( @buffer ) And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY Then
						buffer = GetRelativePath( buffer, CurProjectPath )
						InsertFileToFolderToEnd( GetFolder( @ProjectSettings.Folders, FolderId), buffer )
						SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_ADDSTRING, NULL, Cast( LPARAM, @buffer ) )
					End If
				Next
	
				SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_SETCURSEL, SendDlgItemMessage( hWin, IDC_LSTFILESFILES, LB_GETCOUNT, NULL, NULL ) - 1 , NULL )

			End If

			DragFinish( Cast( HDROP, wParam ) )

			Return 0
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Function FolderNameDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static FolderName As ZString * MAX_PATH+1

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Add NSIS' variables
			SendDlgItemMessage( hWin, IDC_CBOFOLDERNAME, CB_ADDSTRING, 0, Cast( LPARAM, @"$INSTDIR" ) )
			SendDlgItemMessage( hWin, IDC_CBOFOLDERNAME, CB_ADDSTRING, 0, Cast( LPARAM, @"$SYSDIR" ) )
			SendDlgItemMessage( hWin, IDC_CBOFOLDERNAME, CB_ADDSTRING, 0, Cast( LPARAM, @"$WINDIR" ) )

			' Set default value
			If lParam Then
				SetDlgItemText( hWin, IDC_CBOFOLDERNAME, Cast( ZString Ptr, lParam ) )
			End If

			' Subclass edit control to filter input
			Dim CBOEditCtrl As HWND = ChildWindowFromPoint( GetDlgItem( hWin, IDC_CBOFOLDERNAME ), Type <Point> ( 5, 5 ) )
			CreateHook( CBOEditCtrl, @FolderNameEditHook )

			' Set limit of text
			SendMessage( CBOEditCtrl, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Set cursor to end
			' TODO: Doesn't work as expected
			SendMessage( CBOEditCtrl, EM_SETSEL, 0, 0 )
			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDCANCEL
					EndDialog( hWin, NULL )
					'
				Case IDOK
					GetDlgItemText( hWin, IDC_CBOFOLDERNAME, @FolderName, MAX_PATH )
					If FolderName <> "" Then
						EndDialog( hWin, Cast( Integer, @FolderName ) )
					Else
						ErrorBox( hWin, GetTranslateString( "5002", "Please type a folder name." ) )
					End If
					'
			End Select
		Case WM_CLOSE
			EndDialog( hWin, NULL )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Function SelectMainDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static MainProgramFile As ZString * MAX_PATH+1

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			MainProgramFile = ""
			If lParam Then
				Dim CurFilePath As String
				Dim CurFolder As ProjPub_Folder Ptr = Cast( ProjPub_Folder Ptr, lParam )->Next
				Do While CurFolder <> NULL
					Dim CurFile As ProjPub_File Ptr = (@(CurFolder->File))->Next
					Do While CurFile <> NULL
						CurFilePath = *CurFolder->Name & "\" & GetFileName( *CurFile->Name )
						If Right( CurFilePath, 4 ) = ".exe" Then _
							SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_ADDSTRING, NULL, Cast( LPARAM, StrPtr( CurFilePath ) ) )
						CurFile = CurFile->Next
					Loop
					CurFolder = CurFolder->Next
				Loop
				If SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_GETCOUNT, NULL, NULL ) Then
					SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_SETCURSEL, Cast( WPARAM, 0 ), 0 )
				Else
					ErrorBox( hWin, GetTranslateString( "5003", "No files with *.exe extension is found." ) )
					EndDialog( hWin, NULL )
				End If
			End If
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case LBN_DBLCLK
					Select Case LoWord( wParam )
						Case IDC_LSTSELMAINEXE
							Dim CurSel As Integer = SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_GETCURSEL, NULL, NULL )
							If CurSel > -1 Then
								SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_GETTEXT, Cast( WPARAM, CurSel ), Cast( LPARAM, @MainProgramFile ) )
								EndDialog( hWin, Cast( Integer, @MainProgramFile ) )
							Else
								EndDialog( hWin, NULL )
							End If
							'
					End Select
					'
				Case Else
					Select Case LoWord( wParam )
						Case IDOK
							Dim CurSel As Integer = SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_GETCURSEL, NULL, NULL )
							If CurSel > -1 Then
								SendDlgItemMessage( hWin, IDC_LSTSELMAINEXE, LB_GETTEXT, Cast( WPARAM, CurSel ), Cast( LPARAM, @MainProgramFile ) )
								EndDialog( hWin, Cast( Integer, @MainProgramFile ) )
							Else
								EndDialog( hWin, NULL )
							End If
							'
						Case IDCANCEL
							EndDialog( hWin, NULL )
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			EndDialog( hWin, NULL )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Sub ShowFolders( _
	ByVal ListBoxFolderCtrl As HWND, _
	ByVal ListBoxFileCtrl As HWND, _
	ByVal Head As ProjPub_Folder Ptr _
	)

	SendMessage( ListBoxFolderCtrl, LB_RESETCONTENT, NULL, NULL )

	Dim CurFolder As ProjPub_Folder Ptr = Head->Next

	Do While CurFolder <> NULL
		Dim FolderId As Integer = SendMessage( ListBoxFolderCtrl, LB_ADDSTRING, NULL, Cast( LPARAM, CurFolder->Name ) )
		ShowFolderContents( ListBoxFileCtrl, Head, FolderId )
		CurFolder = CurFolder->Next
	Loop

	SendMessage( ListBoxFolderCtrl, LB_SETCURSEL, SendMessage( ListBoxFolderCtrl, LB_GETCOUNT, NULL, NULL ) - 1, NULL )

End Sub

Sub ShowFolderContents( _
	ByVal ListBoxCtrl As HWND, _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal FolderId As Integer _
	)

	SendMessage( ListBoxCtrl, LB_RESETCONTENT, NULL, NULL )

	Dim CurFile As ProjPub_File Ptr = (@(GetFolder( Head, FolderId )->File))->Next

	Do While CurFile <> NULL
		SendMessage( ListBoxCtrl, LB_ADDSTRING, NULL, Cast( LPARAM, CurFile->Name ) )
		CurFile = CurFile->Next
	Loop

	SendMessage( ListBoxCtrl, LB_SETCURSEL, SendMessage( ListBoxCtrl, LB_GETCOUNT, NULL, NULL ) - 1, NULL )

End Sub

'Type ProjPub_File
'	Name As ZString Ptr
'	Next As ProjPub_File Ptr
'End Type
'
'Type ProjPub_Folder
'	Name As ZString Ptr
'	Next As ProjPub_Folder Ptr
'	File As ProjPub_File
'End Type

Sub RemoveFolder( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal id As Integer _
	)

	Dim CurFolder As ProjPub_Folder Ptr = Head
	Dim PrevFolder As ProjPub_Folder Ptr

	For i As Integer = 0 To id
		If CurFolder = NULL Then Return
		PrevFolder = CurFolder
		CurFolder = CurFolder->Next
	Next

	PrevFolder->Next=CurFolder->Next
	Delete[] CurFolder->Name
	RemoveAllFilesInFolder( CurFolder )
	Delete CurFolder

End Sub

Sub RemoveAllFolders( _
	ByVal Head As ProjPub_Folder Ptr _
	)

	Dim NextFolder As ProjPub_Folder Ptr

	Do While Head->Next <> NULL
		NextFolder=Head->Next->Next
		Delete[] Head->Next->Name
		RemoveAllFilesInFolder( Head->Next )
		Delete Head->Next
		Head->Next=NextFolder
	Loop

End Sub

Function GetFoldersNum( _
	ByVal Head As ProjPub_Folder Ptr _
	) As Integer

	Dim CurFolder As ProjPub_Folder Ptr = Head->Next
	Dim Num As Integer

	Do While CurFolder <> NULL
		CurFolder = CurFolder->Next
		Num += 1
	Loop

	Return Num

End Function

Sub InsertFolderToEnd( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByRef FolderName As Const String _
	)

	Dim CurFolder As ProjPub_Folder Ptr = Head

	Do While CurFolder->Next <> NULL
		CurFolder = CurFolder->Next
	Loop

	CurFolder->Next = New ProjPub_Folder
	CurFolder->Next->Name = New Byte [Len( FolderName ) + 1]
	*CurFolder->Next->Name = FolderName
	CurFolder->Next->Next = NULL

End Sub


Sub InsertFolder( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal Id As Integer, _
	ByRef FolderName As Const String _
	)

	Dim CurFolder As ProjPub_Folder Ptr = Head
	Dim TempFolder As ProjPub_Folder Ptr
	Dim CurFolderId As Integer = 0

	Do Until CurFolderId = Id
		If CurFolder->Next <> NULL Then
			CurFolder = CurFolder->Next
		Else
			Return
		End If
		CurFolderId += 1
	Loop

	TempFolder=CurFolder->Next
	CurFolder->Next=New ProjPub_Folder
	CurFolder->Next->Name = New Byte [Len( FolderName ) + 1]
	*CurFolder->Next->Name = FolderName
	CurFolder->Next->Next=TempFolder

End Sub
'/


Sub ReverseFolders( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFolder As ProjPub_Folder Ptr = Head
	Dim CurFolder As ProjPub_Folder Ptr
	Dim NextFolder As ProjPub_Folder Ptr
	Dim TempFolder As ProjPub_Folder Ptr

	If Id+1>=GetFoldersNum( Head ) Then Return
	For i As Integer = 0 To Id-1
		PrevFolder = PrevFolder->Next
	Next

	CurFolder=PrevFolder->Next
	NextFolder=CurFolder->Next
	TempFolder=PrevFolder->Next
	PrevFolder->Next=CurFolder->Next
	CurFolder->Next=NextFolder->Next
	NextFolder->Next=TempFolder
	
End Sub
'/


Sub SetNewFolderName( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal Id As Integer, _
	ByRef FolderName As Const String _
	)

	Dim CurFolder As ProjPub_Folder Ptr = Head

	For i As Integer = 0 To id
		If CurFolder <> NULL Then
			CurFolder = CurFolder->Next
		Else
			Return
		End If
	Next

	Delete[] CurFolder->Name
	CurFolder->Name=New Byte [Len( FolderName ) + 1]
	*CurFolder->Name=FolderName

End Sub
'/

Function GetFolder( _
	ByVal Head As ProjPub_Folder Ptr, _
	ByVal Id As Integer _
	) As ProjPub_Folder Ptr

	Dim CurFolder As ProjPub_Folder Ptr = Head

	For i As Integer = 0 To id
		If CurFolder <> NULL Then
			CurFolder = CurFolder->Next
		Else
			Return NULL
		End If
	Next

	Return CurFolder

End Function

Sub RemoveFileInFolder( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByVal id As Integer _
	)

	Dim CurFile As ProjPub_File Ptr = @Folder->File
	Dim PrevFile As ProjPub_File Ptr

	For i As Integer = 0 To id
		If CurFile = NULL Then Return
		PrevFile = CurFile
		CurFile = CurFile->Next
	Next

	PrevFile->Next=CurFile->Next
	Delete[] CurFile->Name
	Delete CurFile

End Sub

Sub RemoveAllFilesInFolder( _
	ByVal Folder As ProjPub_Folder Ptr _
	)

	Dim NextFile As ProjPub_File Ptr

	Do While (@Folder->File)->Next <> NULL
		NextFile=(@Folder->File)->Next->Next
		Delete[] (@Folder->File)->Next->Name
		Delete (@Folder->File)->Next
		(@Folder->File)->Next=NextFile
	Loop

End Sub

Sub InsertFileToFolderToEnd( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByRef FileName As Const String _
	)

	Dim CurFile As ProjPub_File Ptr = @Folder->File

	Do While CurFile->Next <> NULL
		CurFile = CurFile->Next
	Loop

	CurFile->Next = New ProjPub_File
	CurFile->Next->Name = New Byte [Len( FileName ) + 1]
	*CurFile->Next->Name = FileName
	CurFile->Next->Next = NULL

End Sub


Sub InsertFileToFolder( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByVal Id As Integer, _
	ByRef FileName As Const String _
	)

	Dim CurFile As ProjPub_File Ptr = @Folder->File
	Dim TempFile As ProjPub_File Ptr
	Dim CurFileId As Integer = 0

	Do Until CurFileId = Id
		If CurFile->Next <> NULL Then
			CurFile = CurFile->Next
		Else
			Return
		End If
		CurFileId += 1
	Loop

	TempFile=CurFile->Next
	CurFile->Next=New ProjPub_File
	CurFile->Next->Name = New Byte [Len( FileName ) + 1]
	*CurFile->Next->Name = FileName
	CurFile->Next->Next=TempFile

End Sub
'/

Function GetFilesInFolderNum( _
	ByVal Folder As ProjPub_Folder Ptr _
	) As Integer

	Dim CurFile As ProjPub_File Ptr = (@Folder->File)->Next
	Dim Num As Integer

	Do While CurFile <> NULL
		CurFile = CurFile->Next
		Num += 1
	Loop

	Return Num

End Function


Sub ReverseFilesInFolder( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByVal Id As Integer _
	)

	Dim PrevFile As ProjPub_File Ptr = @Folder->File
	Dim CurFile As ProjPub_File Ptr
	Dim NextFile As ProjPub_File Ptr
	Dim TempFile As ProjPub_File Ptr

	If Id+1>=GetFilesInFolderNum( Folder ) Then Return
	For i As Integer = 0 To Id-1
		PrevFile = PrevFile->Next
	Next

	CurFile=PrevFile->Next
	NextFile=CurFile->Next
	TempFile=PrevFile->Next
	PrevFile->Next=CurFile->Next
	CurFile->Next=NextFile->Next
	NextFile->Next=TempFile
	
End Sub
'/


Sub SetNewFileName( _
	ByVal Folder As ProjPub_Folder Ptr, _
	ByVal Id As Integer, _
	ByRef FileName As Const String _
	)

	Dim CurFile As ProjPub_File Ptr = @Folder->File

	For i As Integer = 0 To id
		If CurFile <> NULL Then
			CurFile = CurFile->Next
		Else
			Return
		End If
	Next

	Delete[] CurFile->Name
	CurFile->Name=New Byte [Len( FileName ) + 1]
	*CurFile->Name=FileName

End Sub
'/
