/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Help.bi"
#Include Once "Finish.bi"
#Include Once "Resource.bi"

Function FinishDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Check run installer if enabled
			If GlobalSettings.RunInstallerDefault Then
				CheckDlgButton( hWin, IDC_CHKFINISHRUN, BST_CHECKED )
			End If

			' Change Welcome/Finish/Failed message static controls font
			SendDlgItemMessage( hWin, IDC_STCFINISH, WM_SETFONT, Cast( WPARAM, WelcomeMsgFont), MAKELPARAM( TRUE, 0 ) )
			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					If LastPublishResult <> 0 Then
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_FINISH )
					'
				Case PSN_WIZFINISH
					If IsDlgButtonChecked( hWin, IDC_CHKFINISHRUN ) = BST_CHECKED Then
						' Run installer
						Dim As STARTUPINFO siStartInfo
						Dim As PROCESS_INFORMATION piProcInfo
						siStartInfo.cb = SizeOf( STARTUPINFO )
						CreateProcess( _
							CurProjectPath & "\" & ProjectSettings.ShortName & "-" & _
								ProjectSettings.VersionMajor & "." & _
								ProjectSettings.VersionMinor & "." & _
								ProjectSettings.VersionBuild & "." & _
								ProjectSettings.VersionRevision & ".exe", _		' installer file name
							NULL, _															' command line 
							NULL, _															' process security attributes 
							NULL, _															' primary thread security attributes 
							FALSE, _															' handles are not inherited 
							CREATE_NEW_PROCESS_GROUP, _								' creation flags
							NULL, _															' use parent's environment 
							NULL, _															' use parent's directory
							@siStartInfo, _												' STARTUPINFO pointer
							@piProcInfo _													' receives PROCESS_INFORMATION
							)
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

