/'
 ' ProjPub - Help Addin for FbEdit (FreeBASIC Editor)
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "File.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "FileFuncs.bi"
#Include Once "MsgBox.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "CustomUI.bi"
#Include Once "Mui.bi"
#Include Once "Resource.bi"

Function MuiDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG

			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4014", "User Interface" ), _
				GetTranslateString( "4015", "Choose the look and feel of your installer." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Add wizards to list box
			If WizardThemesNum Then
				For i As Integer = 0 To WizardThemesNum-1
					SendDlgItemMessage( hWin, IDC_LSTMUIWIZARD, LB_ADDSTRING, NULL, Cast( LPARAM, WizardThemes( i ).Name ) )
				Next
				SendDlgItemMessage( hWin, IDC_LSTMUIWIZARD, LB_SETCURSEL, Cast( WPARAM, WizardThemeDefault ), NULL )
			End If

			' Add headers to list box
			If HeaderThemesNum Then
				For i As Integer = 0 To HeaderThemesNum-1
					SendDlgItemMessage( hWin, IDC_LSTMUIHEADER, LB_ADDSTRING, NULL, Cast( LPARAM, HeaderThemes( i ).Name ) )
				Next
				SendDlgItemMessage( hWin, IDC_LSTMUIHEADER, LB_SETCURSEL, Cast( WPARAM, HeaderThemeDefault ), NULL )
			End If

			' Add icons to list box
			If IconThemesNum Then
				For i As Integer = 0 To IconThemesNum-1
					SendDlgItemMessage( hWin, IDC_LSTMUIICON, LB_ADDSTRING, NULL, Cast( LPARAM, IconThemes( i ).Name ) )
				Next
				SendDlgItemMessage( hWin, IDC_LSTMUIICON, LB_SETCURSEL, Cast( WPARAM, IconThemeDefault ), NULL )
			End If

			' Set defaults
			Dim CurWizardTheme As Integer = GetWizardThemeId( ProjectSettings.WizardInstall )
			Dim CurHeaderTheme As Integer = GetHeaderThemeId( ProjectSettings.HeaderInstall )
			Dim CurIconTheme As Integer = GetIconThemeId( ProjectSettings.IconInstall )
			If (	CurWizardTheme = -1 Or _
					CurHeaderTheme = -1 Or _
					CurIconTheme = -1 _
				) And _
				(	ProjectSettings.WizardInstall <> "" Or _
					ProjectSettings.WizardUninstall <> "" Or _
					ProjectSettings.HeaderInstall <> "" Or _
					ProjectSettings.HeaderInstallRight <> "" Or _
					ProjectSettings.HeaderUninstall <> "" Or _
					ProjectSettings.HeaderUninstallRight <> "" Or _
					ProjectSettings.IconInstall <> "" Or _
					ProjectSettings.IconUninstall <> "" _
				) Then
				CheckDlgButton( hWin, IDC_RBNMUICUSTOM, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIICON, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIHEADER, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
				EnableDlgItem( hWin, IDC_BTNMUICUSTOM, TRUE )
			ElseIf CurWizardTheme <> -1 And _
				CurHeaderTheme <> -1 And _
				CurIconTheme <> -1 Then
				CheckDlgButton( hWin, IDC_RBNMUISTOCK, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, TRUE )
				EnableDlgItem( hWin, IDC_LSTMUIICON, TRUE )
				EnableDlgItem( hWin, IDC_LSTMUIHEADER, TRUE )
				EnableDlgItem( hWin, IDC_BTNMUICUSTOM, FALSE )
				SendDlgItemMessage( hWin, IDC_LSTMUIWIZARD, LB_SETCURSEL, Cast( WPARAM, CurWizardTheme ), NULL )
				SendDlgItemMessage( hWin, IDC_LSTMUIHEADER, LB_SETCURSEL, Cast( WPARAM, CurHeaderTheme ), NULL )
				SendDlgItemMessage( hWin, IDC_LSTMUIICON, LB_SETCURSEL, Cast( WPARAM, CurIconTheme ), NULL )
				If (ProjectSettings.MuiOptions And PROJPUB_MUI_NOWELCOMEFINISHPAGE) <> NULL Then
					EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
					CheckDlgButton( hWin, IDC_CHKMUINOWIZARD, BST_CHECKED )
				Else
					EnableDlgItem( hWin, IDC_LSTMUIWIZARD, TRUE )
				End If
			Else
				CheckDlgButton( hWin, IDC_RBNMUIDEFAULTS, BST_CHECKED )
				EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIICON, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIHEADER, FALSE )
				EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
				EnableDlgItem( hWin, IDC_BTNMUICUSTOM, FALSE )
			End If

			Return FALSE
			'
		Case WM_COMMAND
			Select Case HiWord( wParam )
				Case BN_CLICKED
					Select Case LoWord( wParam )
						Case IDC_RBNMUISTOCK
							If IsDlgButtonChecked( hWin, IDC_RBNMUISTOCK ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, TRUE )
								EnableDlgItem( hWin, IDC_LSTMUIICON, TRUE )
								EnableDlgItem( hWin, IDC_LSTMUIHEADER, TRUE )
								EnableDlgItem( hWin, IDC_BTNMUICUSTOM, FALSE )
								If IsDlgButtonChecked( hWin, IDC_CHKMUINOWIZARD ) = BST_CHECKED Then
									EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
								Else
									EnableDlgItem( hWin, IDC_LSTMUIWIZARD, TRUE )
								End If
							End If
							'
						Case IDC_RBNMUICUSTOM
							If IsDlgButtonChecked( hWin, IDC_RBNMUICUSTOM ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIICON, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIHEADER, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
								EnableDlgItem( hWin, IDC_BTNMUICUSTOM, TRUE )
							End If
							'
						Case IDC_RBNMUIDEFAULTS
							If IsDlgButtonChecked( hWin, IDC_RBNMUIDEFAULTS ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_CHKMUINOWIZARD, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIICON, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIHEADER, FALSE )
								EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
								EnableDlgItem( hWin, IDC_BTNMUICUSTOM, FALSE )
							End If
							'
						Case IDC_CHKMUINOWIZARD
							If IsDlgButtonChecked( hWin, IDC_CHKMUINOWIZARD ) = BST_CHECKED Then
								EnableDlgItem( hWin, IDC_LSTMUIWIZARD, FALSE )
							Else
								EnableDlgItem( hWin, IDC_LSTMUIWIZARD, TRUE )
							End If
							'
						Case IDC_BTNMUICUSTOM
							DialogBox( hInstance, MAKEINTRESOURCE( IDD_DLGCUSTOMUI ), hWin, @CustomUIProjectDialogProc )
							'
					End Select
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					'
				Case PSN_WIZNEXT
					Dim NSISGraphicsPath As String = "${NSISDIR}\Contrib\Graphics"
					If IsDlgButtonChecked( hWin, IDC_RBNMUISTOCK ) = BST_CHECKED Then
						'
						If IsDlgButtonChecked( hWin, IDC_CHKMUINOWIZARD ) = BST_CHECKED Then
							ProjectSettings.MuiOptions Or= PROJPUB_MUI_NOWELCOMEFINISHPAGE
						Else
							ProjectSettings.MuiOptions And= Not PROJPUB_MUI_NOWELCOMEFINISHPAGE
						End If
						Dim CurWizardTheme As Integer = SendDlgItemMessage( hWin, IDC_LSTMUIWIZARD, LB_GETCURSEL, NULL, NULL )
						If CurWizardTheme >= 0 Then
							ProjectSettings.WizardInstall = *WizardThemes( CurWizardTheme ).BitmapInstall
							ProjectSettings.WizardUninstall = *WizardThemes( CurWizardTheme ).BitmapUninstall
							If ProjectSettings.WizardUninstall = "" Then
								ProjectSettings.WizardUninstall = ProjectSettings.WizardInstall
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.WizardInstall ) Then
								ProjectSettings.WizardInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.WizardInstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Wizard\" & ProjectSettings.WizardInstall ) Then
								ProjectSettings.WizardInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Wizard\" & ProjectSettings.WizardInstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Wizard\" & ProjectSettings.WizardInstall ) Then
								ProjectSettings.WizardInstall = NSISGraphicsPath & "\Wizard\" & ProjectSettings.WizardInstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.WizardInstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.WizardUninstall ) Then
								ProjectSettings.WizardUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.WizardUninstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Wizard\" & ProjectSettings.WizardUninstall ) Then
								ProjectSettings.WizardUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Wizard\" & ProjectSettings.WizardUninstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Wizard\" & ProjectSettings.WizardUninstall ) Then
								ProjectSettings.WizardUninstall = NSISGraphicsPath & "\Wizard\" & ProjectSettings.WizardUninstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.WizardUninstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
						Else
							ProjectSettings.WizardInstall = ""
							ProjectSettings.WizardUninstall = ""
						End If
						'
						Dim CurHeaderTheme As Integer = SendDlgItemMessage( hWin, IDC_LSTMUIHEADER, LB_GETCURSEL, NULL, NULL )
						If CurHeaderTheme >= 0 Then
							ProjectSettings.HeaderInstall = *HeaderThemes( CurHeaderTheme ).BitmapInstall
							ProjectSettings.HeaderInstallRight = *HeaderThemes( CurHeaderTheme ).BitmapInstallRight
							ProjectSettings.HeaderUninstall = *HeaderThemes( CurHeaderTheme ).BitmapUninstall
							ProjectSettings.HeaderUninstallRight = *HeaderThemes( CurHeaderTheme ).BitmapUninstallRight
							If ProjectSettings.HeaderInstallRight = "" Then
								ProjectSettings.HeaderInstallRight = ProjectSettings.HeaderInstall
							End If
							If ProjectSettings.HeaderUninstall = "" Then
								ProjectSettings.HeaderUninstall = ProjectSettings.HeaderInstall
							End If
							If ProjectSettings.HeaderUninstallRight = "" Then
								ProjectSettings.HeaderUninstallRight = ProjectSettings.HeaderInstallRight
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderInstall ) Then
								ProjectSettings.HeaderInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderInstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderInstall ) Then
								ProjectSettings.HeaderInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderInstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Header\" & ProjectSettings.HeaderInstall ) Then
								ProjectSettings.HeaderInstall = NSISGraphicsPath & "\Header\" & ProjectSettings.HeaderInstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.HeaderInstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderInstallRight ) Then
								ProjectSettings.HeaderInstallRight = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderInstallRight, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderInstallRight ) Then
								ProjectSettings.HeaderInstallRight = GetRelativePath( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderInstallRight, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Header\" & ProjectSettings.HeaderInstallRight ) Then
								ProjectSettings.HeaderInstallRight = NSISGraphicsPath & "\Header\" & ProjectSettings.HeaderInstallRight
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.HeaderInstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderUninstall ) Then
								ProjectSettings.HeaderUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderUninstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderUninstall ) Then
								ProjectSettings.HeaderUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderUninstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Header\" & ProjectSettings.HeaderUninstall ) Then
								ProjectSettings.HeaderUninstall = NSISGraphicsPath & "\Header\" & ProjectSettings.HeaderUninstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.HeaderInstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderUninstallRight ) Then
								ProjectSettings.HeaderUninstallRight = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.HeaderUninstallRight, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderUninstallRight ) Then
								ProjectSettings.HeaderUninstallRight = GetRelativePath( IDEPath + "\ProjPub\Graphics\Header\" & ProjectSettings.HeaderUninstallRight, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Header\" & ProjectSettings.HeaderUninstallRight ) Then
								ProjectSettings.HeaderUninstallRight = NSISGraphicsPath & "\Header\" & ProjectSettings.HeaderUninstallRight
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.HeaderUninstallRight )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
						Else
							ProjectSettings.HeaderInstall = ""
							ProjectSettings.HeaderInstallRight = ""
							ProjectSettings.HeaderUninstall = ""
							ProjectSettings.HeaderUninstallRight = ""
						End If
						'
						Dim CurIconTheme As Integer = SendDlgItemMessage( hWin, IDC_LSTMUIICON, LB_GETCURSEL, NULL, NULL )
						If CurIconTheme >= 0 Then
							ProjectSettings.IconInstall = *IconThemes( CurIconTheme ).IconInstall
							ProjectSettings.IconUninstall = *IconThemes( CurIconTheme ).IconUninstall
							If ProjectSettings.IconUninstall = "" Then
								ProjectSettings.IconUninstall = ProjectSettings.IconInstall
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.IconInstall ) Then
								ProjectSettings.IconInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.IconInstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Icons\" & ProjectSettings.IconInstall ) Then
								ProjectSettings.IconInstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Icons\" & ProjectSettings.IconInstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Icons\" & ProjectSettings.IconInstall ) Then
								ProjectSettings.IconInstall = NSISGraphicsPath & "\Icons\" & ProjectSettings.IconInstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.IconInstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
							'
							If FileExists( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.IconUninstall ) Then
								ProjectSettings.IconUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Custom\" & ProjectSettings.IconUninstall, CurProjectPath )
							ElseIf FileExists( IDEPath + "\ProjPub\Graphics\Icons\" & ProjectSettings.IconUninstall ) Then
								ProjectSettings.IconUninstall = GetRelativePath( IDEPath + "\ProjPub\Graphics\Icons\" & ProjectSettings.IconUninstall, CurProjectPath )
							ElseIf FileExists( GetDir( GlobalSettings.NSISPath ) & "\Contrib\Graphics\Icons\" & ProjectSettings.IconUninstall ) Then
								ProjectSettings.IconUninstall = NSISGraphicsPath & "\Icons\" & ProjectSettings.IconUninstall
							Else
								ErrorBox( hWin, GetTranslateString( "5005", "File not found:" ) & " " & ProjectSettings.IconUninstall )
								SetWindowLong( hWin, DWL_MSGRESULT, -1 )
								Return -1
							End If
						Else
							ProjectSettings.IconInstall = ""
							ProjectSettings.IconUninstall = ""
						End If
						'
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNMUICUSTOM ) = BST_CHECKED Then
						GetDlgItemText( hWin, IDC_EDTLICENSECUSTOM, @buffer, MAX_PATH )
						ProjectSettings.MuiOptions = 0
						'
					ElseIf IsDlgButtonChecked( hWin, IDC_RBNMUIDEFAULTS ) = BST_CHECKED Then
						ProjectSettings.MuiOptions = 0
						ProjectSettings.WizardInstall = ""
						ProjectSettings.WizardUninstall = ""
						ProjectSettings.HeaderInstall = ""
						ProjectSettings.HeaderInstallRight = ""
						ProjectSettings.HeaderUninstall = ""
						ProjectSettings.HeaderUninstallRight = ""
						ProjectSettings.IconInstall = ""
						ProjectSettings.IconUninstall = ""
						'
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

Sub LoadGraphics( _
	ByRef Location As Const String _
	)

	Dim wfd As WIN32_FIND_DATA
	Dim hwfd As HANDLE
	Dim CurFile As String

	' Find all files in path
	hwfd = FindFirstFile( Location & "\*.*", @wfd )
	If hwfd <> INVALID_HANDLE_VALUE Then
		Do
			If (wfd.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = NULL Then
				' A file is found, is it a *.grp file
				If LCase( Right( wfd.cFileName, 4 ) ) = ".grp" Then
					CurFile = Location & "\" & wfd.cFileName
					' Check Graphics type and add to list
					GetPrivateProfileString( "ProjPub", "FileType", "", @buffer, MAX_PATH, CurFile )
					Select Case buffer
						Case "Graphic-Wizard"
							AddToWizardThemes( CurFile )
							'
						Case "Graphic-Header"
							AddToHeaderThemes( CurFile )
							'
						Case "Graphic-Icon"
							AddToIconThemes( CurFile )
							'
					End Select
				End If
			Else
				' A new path is found
				If wfd.cFileName <> "." And wfd.cFileName <> ".." Then
					' Call myself to scan this path
					CurFile = Location & "\" & wfd.cFileName
					LoadGraphics( CurFile )
				End If
			End If
			If FindNextFile( hwfd, @wfd ) = FALSE Then
				' No more files in this path
				Exit Do
			End If
		Loop
		' Close the find handle
		FindClose( hwfd )
	End If

End Sub


Sub FreeGraphics( _
	)

	If WizardThemesMax Then
		For i As Integer = 0 To WizardThemesMax-1
			Delete[] WizardThemes( i ).Name
			Delete[] WizardThemes( i ).DescFile
			Delete[] WizardThemes( i ).BitmapInstall
			Delete[] WizardThemes( i ).BitmapUninstall
		Next
	End If

	If HeaderThemesMax Then
		For i As Integer = 0 To HeaderThemesMax-1
			Delete[] HeaderThemes( i ).Name
			Delete[] HeaderThemes( i ).DescFile
			Delete[] HeaderThemes( i ).BitmapInstall
			Delete[] HeaderThemes( i ).BitmapInstallRight
			Delete[] HeaderThemes( i ).BitmapUninstall
			Delete[] HeaderThemes( i ).BitmapUninstallRight
		Next
	End If

	If IconThemesMax Then
		For i As Integer = 0 To IconThemesMax-1
			Delete[] IconThemes( i ).Name
			Delete[] IconThemes( i ).DescFile
			Delete[] IconThemes( i ).IconInstall
			Delete[] IconThemes( i ).IconUninstall
		Next
	End If

End Sub

Sub AddToWizardThemes( _
	ByVal Filename As String _
	)

	Dim size As Integer

	' Check if the array can accomodate the number of files available
	If WizardThemesNum >= WizardThemesMax Then

		'' There are more files than the array can provide
		WizardThemesMax += THEMES_INCREASE
		ReDim Preserve WizardThemes(WizardThemesMax - 1) As WizardTheme

	End If

	' Set filename of the current Wizard Themes
	WizardThemes( WizardThemesNum ).DescFile = New Byte[Len(Filename)+1]
	*WizardThemes( WizardThemesNum ).DescFile = Filename

	' Set Wizard Theme info
	size = GetPrivateProfileString( "Graphic-Wizard", "Name", "Unnamed", @buffer, MAX_PATH, Filename )
	WizardThemes( WizardThemesNum ).Name = New Byte[size+1]
	*WizardThemes( WizardThemesNum ).Name = buffer
	size = GetPrivateProfileString( "Graphic-Wizard", "Bitmap-Install", "", @buffer, MAX_PATH, Filename )
	WizardThemes( WizardThemesNum ).BitmapInstall = New Byte[size+1]
	*WizardThemes( WizardThemesNum ).BitmapInstall = buffer
	size = GetPrivateProfileString( "Graphic-Wizard", "Bitmap-Uninstall", "", @buffer, MAX_PATH, Filename )
	WizardThemes( WizardThemesNum ).BitmapUninstall = New Byte[size+1]
	*WizardThemes( WizardThemesNum ).BitmapUninstall = buffer

	' Check if default is requested
	If GetPrivateProfileInt( "ProjPub", "Default", 0, Filename ) Then
		WizardThemeDefault = WizardThemesNum
	End If

	' Increment Wizard Themes counter
	WizardThemesNum += 1

End Sub

Sub AddToHeaderThemes( _
	ByVal Filename As String _
	)

	Dim size As Integer

	' Check if the array can accomodate the number of files available
	If HeaderThemesNum >= HeaderThemesMax Then

		'' There are more files than the array can provide
		HeaderThemesMax += THEMES_INCREASE
		ReDim Preserve HeaderThemes(HeaderThemesMax - 1) As HeaderTheme

	End If

	' Set filename of the current Header Themes
	HeaderThemes( HeaderThemesNum ).DescFile = New Byte[Len(Filename)+1]
	*HeaderThemes( HeaderThemesNum ).DescFile = Filename

	' Set Header Theme info
	size = GetPrivateProfileString( "Graphic-Header", "Name", "Unnamed", @buffer, MAX_PATH, Filename )
	HeaderThemes( HeaderThemesNum ).Name = New Byte[size+1]
	*HeaderThemes( HeaderThemesNum ).Name = buffer
	size = GetPrivateProfileString( "Graphic-Header", "Bitmap-Install", "", @buffer, MAX_PATH, Filename )
	HeaderThemes( HeaderThemesNum ).BitmapInstall = New Byte[size+1]
	*HeaderThemes( HeaderThemesNum ).BitmapInstall = buffer
	size = GetPrivateProfileString( "Graphic-Header", "Bitmap-Install-Right", "", @buffer, MAX_PATH, Filename )
	HeaderThemes( HeaderThemesNum ).BitmapInstallRight = New Byte[size+1]
	*HeaderThemes( HeaderThemesNum ).BitmapInstallRight = buffer
	size = GetPrivateProfileString( "Graphic-Header", "Bitmap-Uninstall", "", @buffer, MAX_PATH, Filename )
	HeaderThemes( HeaderThemesNum ).BitmapUninstall = New Byte[size+1]
	*HeaderThemes( HeaderThemesNum ).BitmapUninstall = buffer
	size = GetPrivateProfileString( "Graphic-Header", "Bitmap-Uninstall-Right", "", @buffer, MAX_PATH, Filename )
	HeaderThemes( HeaderThemesNum ).BitmapUninstallRight = New Byte[size+1]
	*HeaderThemes( HeaderThemesNum ).BitmapUninstallRight = buffer

	' Check if default is requested
	If GetPrivateProfileInt( "ProjPub", "Default", 0, Filename ) Then
		HeaderThemeDefault = HeaderThemesNum
	End If

	' Increment Header Themes counter
	HeaderThemesNum += 1

End Sub

Sub AddToIconThemes( _
	ByVal Filename As String _
	)

	Dim size As Integer

	' Check if the array can accomodate the number of files available
	If IconThemesNum >= IconThemesMax Then

		'' There are more files than the array can provide
		IconThemesMax += THEMES_INCREASE
		ReDim Preserve IconThemes(IconThemesMax - 1) As IconTheme

	End If

	' Set filename of the current Icon Themes
	IconThemes( IconThemesNum ).DescFile = New Byte[Len(Filename)+1]
	*IconThemes( IconThemesNum ).DescFile = Filename

	' Set Icon Theme info
	size = GetPrivateProfileString( "Graphic-Icon", "Name", "Unnamed", @buffer, MAX_PATH, Filename )
	IconThemes( IconThemesNum ).Name = New Byte[size+1]
	*IconThemes( IconThemesNum ).Name = buffer
	size = GetPrivateProfileString( "Graphic-Icon", "Icon-Install", "", @buffer, MAX_PATH, Filename )
	IconThemes( IconThemesNum ).IconInstall = New Byte[size+1]
	*IconThemes( IconThemesNum ).IconInstall = buffer
	size = GetPrivateProfileString( "Graphic-Icon", "Icon-Uninstall", "", @buffer, MAX_PATH, Filename )
	IconThemes( IconThemesNum ).IconUninstall = New Byte[size+1]
	*IconThemes( IconThemesNum ).IconUninstall = buffer

	' Check if default is requested
	If GetPrivateProfileInt( "ProjPub", "Default", 0, Filename ) Then
		IconThemeDefault = IconThemesNum
	End If

	' Increment Icon Themes counter
	IconThemesNum += 1

End Sub

Function GetWizardThemeId( _
	ByRef filename As Const String _
	) As Integer

	If WizardThemesNum Then
		For i As Integer = 0 To WizardThemesNum-1
			If LCase( GetFileName( *WizardThemes(i).BitmapInstall ) ) = LCase( GetFileName( filename ) ) Then
				Return i
			End If
		Next
	End If

	Return -1

End Function

Function GetHeaderThemeId( _
	ByRef filename As Const String _
	) As Integer

	If HeaderThemesNum Then
		For i As Integer = 0 To HeaderThemesNum-1
			If LCase( GetFileName( *HeaderThemes(i).BitmapInstall ) ) = LCase( GetFileName( filename ) ) Then
				Return i
			End If
		Next
	End If

	Return -1

End Function

Function GetIconThemeId( _
	ByRef filename As Const String _
	) As Integer

	If IconThemesNum Then
		For i As Integer = 0 To IconThemesNum-1
			If LCase( GetFileName( *IconThemes(i).IconInstall ) ) = LCase( GetFileName( filename ) ) Then
				Return i
			End If
		Next
	End If

	Return -1

End Function

