/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "ProjType.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "OpenWith.bi"
#Include Once "Resource.bi"

Function OpenWithDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4024", "Open With" ), _
				GetTranslateString( "4025", "Choose the open command for the Open With dialog box." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Set limit of text
			SendDlgItemMessage( hWin, IDC_EDTOPENWITHCOMMAND, EM_SETLIMITTEXT, MAX_PATH, NULL )

			' Set defaults
			If ProjectSettings.OpenWithCommand <> "" Then
				EnableDlgItem( hWin, IDC_EDTOPENWITHCOMMAND, TRUE )
				EnableDlgItem( hWin, IDC_BTNOPENWITHUSEMAIN, TRUE )
				CheckDlgButton( hWin, IDC_CHKOPENWITHCOMMAND, BST_CHECKED )
				SetDlgItemText( hWin, IDC_EDTOPENWITHCOMMAND, @ProjectSettings.OpenWithCommand )
			Else
				EnableDlgItem( hWin, IDC_EDTOPENWITHCOMMAND, FALSE )
				EnableDlgItem( hWin, IDC_BTNOPENWITHUSEMAIN, FALSE )
			End If
			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDC_BTNOPENWITHUSEMAIN
					If ProjectSettings.MainProgram <> "" Then
						SetDlgItemText( hWin, IDC_EDTOPENWITHCOMMAND, """" & ProjectSettings.MainProgram & """ ""%1""" )
					End If
					'
				Case IDC_CHKOPENWITHCOMMAND
					If IsDlgButtonChecked( hWin, IDC_CHKOPENWITHCOMMAND ) = BST_CHECKED Then
						EnableDlgItem( hWin, IDC_EDTOPENWITHCOMMAND, TRUE )
						EnableDlgItem( hWin, IDC_BTNOPENWITHUSEMAIN, TRUE )
					Else
						EnableDlgItem( hWin, IDC_EDTOPENWITHCOMMAND, FALSE )
						EnableDlgItem( hWin, IDC_BTNOPENWITHUSEMAIN, FALSE )
					End If
					'
			End Select
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If ProjectSettings.ProjectType = PROJPUB_PROJTYPE_BASIC Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_GAME Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_FBEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_RAADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_MEADDIN Or _
						ProjectSettings.ProjectType = PROJPUB_PROJTYPE_APPPLUGIN Then
						ProjectSettings.OpenWithCommand = ""
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					'
				Case PSN_WIZNEXT
					If IsDlgButtonChecked( hWin, IDC_CHKOPENWITHCOMMAND ) = BST_CHECKED Then
						GetDlgItemText( hWin, IDC_EDTOPENWITHCOMMAND, ProjectSettings.OpenWithCommand, MAX_PATH )
					Else
						ProjectSettings.OpenWithCommand = ""
					End If
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

