/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "RemDrvInst.bi"
#Include Once "Shortcuts.bi"
#Include Once "Settings.bi"
#Include Once "Header.bi"
#Include Once "Help.bi"
#Include Once "Preview.bi"
#Include Once "Resource.bi"

Function PreviewDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Add header
			AddHeaderToPage( hWin, _
				GetTranslateString( "4030", "Ready To Publish!" ), _
				GetTranslateString( "4031", "The wizard is now ready to publish your project." ) _
				)

			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Remove focus from preview edit box
			' TODO: Doesn't work
			SetFocus( GetParent( hWin ) )
			Return FALSE
			'
		Case WM_CTLCOLORSTATIC
			' Change Preview edit control's background color
			Return Cast( Integer, GetStockObject( WHITE_BRUSH ) )
			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow(hWin)
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_BACK Or PSWIZB_NEXT )
					If LastPublishResult Then
						LastPublishResult = 0
						SetWindowLong( hWin, DWL_MSGRESULT, -1 )
						Return TRUE
					End If
					Dim PreviewString As String
					PreviewString &= GetTranslateString( "7000", "The application will be published to:" ) & !"\r\n"
					PreviewString &= CurProjectPath & "\" & !"\r\n"
					PreviewString &= !"\r\n"

					If ( _
							(DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = NULL And _
							ProjectSettings.RemDrvInst <> PROJPUB_REMDRVINST_DISABLE _
						) Or _
						( _
							(DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = NULL And _
							ProjectSettings.FileAssociations.Next <> NULL _
						) Then

						PreviewString &= GetTranslateString( "7001", "When installing the application:" ) & !"\r\n"

						If (DisabledFeatures And PROJPUB_FEATURES_REMDRVINST) = NULL And _
							ProjectSettings.RemDrvInst <> PROJPUB_REMDRVINST_DISABLE Then
							PreviewString &= !"   * " & GetTranslateString( "7002", "The installer will check if installing in a removable media" ) & !"\r\n"
							PreviewString &= !"\r\n"
						End If

						If (DisabledFeatures And PROJPUB_FEATURES_FILEASSOC) = NULL And _
							ProjectSettings.FileAssociations.Next <> NULL Then
							PreviewString &= !"   * " & GetTranslateString( "7003", "Options will be shown for associating the application with the selected file types" ) & !"\r\n"
						End If

					End If

					PreviewString &= GetTranslateString( "7004", "When this application is installed on the client machine:" ) & !"\r\n"
					If (DisabledFeatures And PROJPUB_FEATURES_SHORTCUTS) = NULL And _
						ProjectSettings.ShortcutOptions <> 0 Then
						If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAINPROGRAM) <> NULL Then
							PreviewString &= !"   * " & GetTranslateString( "7005", "A shortcut to the application will be added in the Start Menu" ) & !"\r\n"
						End If
						If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_UNINSTALLER) <> NULL Then
							PreviewString &= !"   * " & GetTranslateString( "7006", "A shortcut to the uninstaller will be added in the Start Menu" ) & !"\r\n"
						End If
						If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_PRJWEBSITE) <> NULL Then
							PreviewString &= !"   * " & GetTranslateString( "7007", "A shortcut to the project website will be added in the Start Menu" ) & !"\r\n"
						End If
						If (ProjectSettings.ShortcutOptions And PROJPUB_SHORTCUT_MAININDESKTOP) <> NULL Then
							PreviewString &= !"   * " & GetTranslateString( "7008", "A shortcut to the application will be added in the Desktop" ) & !"\r\n"
						End If
					End If
					PreviewString &= !"   * " & GetTranslateString( "7009", "The application can be uninstalled via Add/Remove Programs" )

					SetDlgItemText( hWin, IDC_EDTPREVIEW, StrPtr( PreviewString ) )
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

