/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEd
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

'#Define _WIN32_IE &h0400

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "File.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "FileFuncs.bi"
#Include Once "Files.bi"
#Include Once "License.bi"
#Include Once "MultiUser.bi"
#Include Once "Shortcuts.bi"
#Include Once "FileAssoc.bi"
#Include Once "Compressor.bi"
#Include Once "Help.bi"
#Include Once "CustomUI.bi"
#Include Once "Settings.bi"
#Include Once "Resource.bi"


Function SettingsDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Static FileTypeIdOfContextMenus As Integer
	Static ContextMenuItemIsChanging As BOOL = FALSE

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			SetDlgItemText( hWin, IDC_EDTSETTINGSNSISPATH, @GlobalSettings.NSISPath )
			SetDlgItemText( hWin, IDC_EDTSETTINGSAUTHOR, @GlobalSettings.Author )
			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDOK
					GetDlgItemText( hWin, IDC_EDTSETTINGSNSISPATH, @GlobalSettings.NSISPath, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTSETTINGSAUTHOR, @GlobalSettings.Author, MAX_PATH )
					If IsDlgButtonChecked( hWin, IDC_CHKSETTINGSRUNDEFAULT ) = BST_CHECKED Then
						GlobalSettings.RunInstallerDefault = 1
					Else
						GlobalSettings.RunInstallerDefault = 0
					End If
					If IsDlgButtonChecked( hWin, IDC_CHKSETTINGSCOMPRESSORPAGE ) = BST_CHECKED Then
						GlobalSettings.ShowCompressorPage = 1
					Else
						GlobalSettings.ShowCompressorPage = 0
					End If
					Select Case CurIDE
						Case IDE_FBEDIT
							SaveSettingsIni( @lpFbEData->IniFile )
							'
						Case IDE_RADASM2
							SaveSettingsIni( lpRa2Data->lpIniFile )
							'
						Case IDE_RADASM3
							SaveSettingsIni( lpRa3Data->szRadASMIni )
							'
						Case IDE_MASMED
							SaveSettingsRegistry( HKEY_CURRENT_USER, "Software\MasmEd1000\MasmEd" )
							'
					End Select
					EndDialog( hWin, TRUE )
					'
				Case IDCANCEL
					EndDialog( hWin, FALSE )
					'
				Case IDC_BTNSETTINGSNSISPATHBROWSE
					If GlobalSettings.NSISPath <> "" Then
						buffer = GlobalSettings.NSISPath
					Else
						buffer = IDEPath
					End If
					Dim NSISPath As String = GetRelativePath( _
						OpenFileName( _
							hWin, _
							GetTranslateString( "6003", "Select MakeNSIS" ), _
							buffer, _
							!"makensis.exe\0makensis.exe\0" _
							), _
						IDEPath _
						)
					If NSISPath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTSETTINGSNSISPATH, NSISPath )
					'
				Case IDC_BTNSETTINGSDEFAULTCUSTOMUI
					DialogBox( hInstance, MAKEINTRESOURCE( IDD_DLGCUSTOMUI ), hWin, @CustomUIGlobalDialogProc )
					'
			End Select
			'
		Case WM_CLOSE
			EndDialog( hWin, FALSE )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Sub SetDefaultSettings( _
	)

	If GlobalSettings.Author = "" Then
		Dim RegOwnerKey As HKEY
		Dim buffer_size As Integer = MAX_PATH
		If RegOpenKeyEx( HKEY_LOCAL_MACHINE, "Software\Microsoft\Windows NT\CurrentVersion", NULL, KEY_QUERY_VALUE, @RegOwnerKey ) = ERROR_SUCCESS Then
			If RegQueryValueEx( RegOwnerKey, "RegisteredOwner", NULL, NULL, @buffer, @buffer_size ) = ERROR_SUCCESS Then
				GlobalSettings.Author = buffer
			End If
			RegCloseKey( RegOwnerKey )
		Else
			Dim UserNameSize As Integer = MAX_PATH
			GetUserName( @GlobalSettings.Author, @UserNameSize )
		End If
	End If

	If GlobalSettings.NSISPath = "" Then
		Dim NSISKey As HKEY
		Dim buffer_size As Integer = MAX_PATH
		If RegOpenKeyEx( HKEY_LOCAL_MACHINE, "Software\NSIS", NULL, KEY_QUERY_VALUE, @NSISKey ) = ERROR_SUCCESS Then
			If RegQueryValueEx( NSISKey, "", NULL, NULL, @buffer, @buffer_size ) = ERROR_SUCCESS Then
				GlobalSettings.NSISPath = buffer & "\makensis.exe"
			End If
			RegCloseKey( NSISKey )
		ElseIf RegOpenKeyEx( HKEY_CURRENT_USER, "Software\NSIS", NULL, KEY_QUERY_VALUE, @NSISKey ) = ERROR_SUCCESS Then
			If RegQueryValueEx( NSISKey, "", NULL, NULL, @buffer, @buffer_size ) = ERROR_SUCCESS Then
				GlobalSettings.NSISPath = buffer & "\makensis.exe"
			End If
			RegCloseKey( NSISKey )
		End If
	End If

End Sub


Sub SaveSettingsIni( _
	ByVal SettingsFile As ZString Ptr _
	)

	WritePrivateProfileString( ADDIN_NAME, "NSISPath", @GlobalSettings.NSISPath, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "Author", @GlobalSettings.Author, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "WizardInstall", @GlobalSettings.WizardInstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "WizardUninstall", @GlobalSettings.WizardUninstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderInstall", @GlobalSettings.HeaderInstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderInstallRight", @GlobalSettings.HeaderInstallRight, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderUninstall", @GlobalSettings.HeaderUninstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderUninstallRight", @GlobalSettings.HeaderUninstallRight, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "IconInstall", @GlobalSettings.IconInstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "IconUninstall", @GlobalSettings.IconUninstall, SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "RunInstallerDefault", Str( GlobalSettings.RunInstallerDefault ), SettingsFile )
	WritePrivateProfileString( ADDIN_NAME, "ShowCompressorPage", Str( GlobalSettings.ShowCompressorPage ), SettingsFile )

End Sub


Sub LoadSettingsIni( _
	ByVal SettingsFile As ZString Ptr _
	)

	GetPrivateProfileString( ADDIN_NAME, "NSISPath", "", @GlobalSettings.NSISPath, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "Author", "", @GlobalSettings.Author, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "WizardInstall", "", @GlobalSettings.WizardInstall, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "WizardUninstall", "", @GlobalSettings.WizardUninstall, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderInstall", "", @GlobalSettings.HeaderInstall, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderInstallRight", "", @GlobalSettings.HeaderInstallRight, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderUninstall", "", @GlobalSettings.HeaderUninstall, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderUninstallRight", "", @GlobalSettings.HeaderUninstallRight, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "IconInstall", "", @GlobalSettings.IconInstall, MAX_PATH, SettingsFile )
	GetPrivateProfileString( ADDIN_NAME, "IconUninstall", "", @GlobalSettings.IconUninstall, MAX_PATH, SettingsFile )
	GlobalSettings.RunInstallerDefault = Cast( Byte, GetPrivateProfileInt( ADDIN_NAME, "RunInstallerDefault", 0, SettingsFile ) )
	GlobalSettings.ShowCompressorPage = Cast( Byte, GetPrivateProfileInt( ADDIN_NAME, "ShowCompressorPage", 0, SettingsFile ) )

	' Set defaults
	SetDefaultSettings

End Sub


Sub SaveSettingsRegistry( _
	ByVal hKey As HKEY, _
	ByVal lpSubKey As ZString Ptr _
	)

	Dim RegIDE As HKEY
	If RegOpenKeyEx( hKey, lpSubKey, NULL, KEY_WRITE, @RegIDE ) = ERROR_SUCCESS Then
		RegSetValueEx( RegIDE, "ProjPub", NULL, REG_BINARY, Cast( LPBYTE, @GlobalSettings ), SizeOf( ProjPub_Settings ) )
		RegCloseKey( RegIDE )
	End If

End Sub


Sub LoadSettingsRegistry( _
	ByVal hKey As HKEY, _
	ByVal lpSubKey As ZString Ptr _
	)

	Dim RegIDE As HKEY
	Dim SizeOfProjPubSettings As Integer = SizeOf( ProjPub_Settings )
	If RegOpenKeyEx( hKey, lpSubKey, NULL, KEY_READ, @RegIDE ) = ERROR_SUCCESS Then
		RegQueryValueEx( RegIDE, "ProjPub", NULL, NULL, Cast( LPBYTE, @GlobalSettings ), @SizeOfProjPubSettings )
		RegCloseKey( RegIDE )
	End If

	' Set defaults
	SetDefaultSettings

End Sub


Sub SetDefaultProjectSettings( _
	ByVal ProjectFile As ZString Ptr _
	)

	If ProjectSettings.Author = "" Then
		ProjectSettings.Author = GlobalSettings.Author
	End If

	If ProjectSettings.Version = "" Then
		ProjectSettings.Version = "1.0"
	End If

	If ProjectSettings.VersionMajor = 0 And _
		ProjectSettings.VersionMinor = 0 And _
		ProjectSettings.VersionBuild = 0 And _
		ProjectSettings.VersionRevision = 0 Then
		ProjectSettings.VersionMajor = 1
	End If

	If ProjectSettings.Name = "" Then
		GetPrivateProfileString( "Project", "Description", "", @ProjectSettings.Name, MAX_PATH, ProjectFile )
		ProjectSettings.ExecLevel = PROJPUB_EXECLEVEL_HIGHEST
		ProjectSettings.ShortcutOptions = PROJPUB_SHORTCUT_MAINPROGRAM Or _
			PROJPUB_SHORTCUT_MAININDESKTOP Or _
			PROJPUB_SHORTCUT_UNINSTALLER
		ProjectSettings.Compressor = PROJPUB_COMPRESSOR_LZMA
		ProjectSettings.CompressorOptions = PROJPUB_COMPRESSOR_SOLID
	End If

	If ProjectSettings.ShortName = "" Then
		ProjectSettings.ShortName = GetBaseName( CurProjectFile )
		If ProjectSettings.Name = "" Then
			ProjectSettings.Name = ProjectSettings.ShortName
		End If
	End If

	If ProjectSettings.License = "" Then
		If FileExists( CurProjectPath + "\" + "copying.txt" ) Then
			ProjectSettings.License = "copying.txt"
		ElseIf FileExists( CurProjectPath + "\" + "copying.rtf" ) Then
			ProjectSettings.License = "copying.rtf"
		ElseIf LicensesNum Then
			ProjectSettings.License = *Licenses(LicenseDefault).Contents
		End If
	End If

	If ProjectSettings.InstallFolder = "" Then
		ProjectSettings.InstallFolder = ProjectSettings.Name
	End If

	If ProjectSettings.Uninstaller = "" Then
		ProjectSettings.Uninstaller = "uninstall.exe"
	End If

	Dim CurEntry As Integer

	Do
		CurEntry += 1
		Dim EntryType As String
		Dim EntryValue As String
		Dim SepPos As Integer
		GetPrivateProfileString( ADDIN_NAME, "Files" & CurEntry, "", @buffer, MAX_PATH, ProjectFile )
		If buffer <> "" Then
			SepPos = InStr( buffer, "|" )
			If SepPos Then
				EntryType = Left( buffer, SepPos-1 )
				If LCase( Trim( EntryType ) ) = LCase( "Folder" ) Then
					InsertFolderToEnd( @ProjectSettings.Folders, Trim( Mid( buffer, SepPos+1 ) ) )
				End If
			Else
				Dim FoldersNum As Integer = GetFoldersNum( @ProjectSettings.Folders )
				If FoldersNum Then
					InsertFileToFolderToEnd( GetFolder( @ProjectSettings.Folders, FoldersNum-1 ), buffer )
				End If
			End If
		Else
			Exit Do
		End If
	Loop

	CurEntry = 0

	Do
		CurEntry += 1
		Dim EntryType As String
		Dim EntryValue As String
		Dim SepPos As Integer
		GetPrivateProfileString( ADDIN_NAME, "FileTypes" & CurEntry, "", @buffer, MAX_PATH, ProjectFile )
		If buffer <> "" Then
			SepPos = InStr( buffer, "|" )
			If SepPos Then
				EntryType = Left( buffer, SepPos-1 )
				If LCase( Trim( EntryType ) ) = LCase( "FileType" ) Then
					buffer = Mid( buffer, SepPos+1 )
					SepPos = InStr( buffer, "|" )
					If SepPos = 0 Then Exit Do
					Dim EntryExt As String = Trim( Left( buffer, SepPos-1 ) )
					buffer = Mid( buffer, SepPos+1 )
					SepPos = InStr( buffer, "|" )
					If SepPos = 0 Then Exit Do
					Dim EntryAppIdKey As String = Trim( Left( buffer, SepPos-1 ) )
					buffer = Mid( buffer, SepPos+1 )
					SepPos = InStr( buffer, "|" )
					If SepPos = 0 Then Exit Do
					Dim EntryDescription As String = Trim( Left( buffer, SepPos-1 ) )
					Dim EntryDefaultIcon As String = Trim( Mid( buffer, SepPos+1 ) )
					InsertFileTypeToEnd( @ProjectSettings.FileAssociations, EntryExt, EntryAppIdKey, EntryDescription, EntryDefaultIcon )
				ElseIf LCase( Trim( EntryType ) ) = LCase( "ContextMenu" ) Then
					Dim FileTypesNum As Integer = GetFileTypesNum( @ProjectSettings.FileAssociations )
					If FileTypesNum Then
						buffer = Mid( buffer, SepPos+1 )
						SepPos = InStr( buffer, "|" )
						If SepPos = 0 Then Exit Do
						Dim EntryVerb As String = Trim( Left( buffer, SepPos-1 ) )
						buffer = Mid( buffer, SepPos+1 )
						SepPos = InStr( buffer, "|" )
						If SepPos = 0 Then Exit Do
						Dim EntryItemText As String = Trim( Left( buffer, SepPos-1 ) )
						Dim EntryCommand As String = Trim( Mid( buffer, SepPos+1 ) )
						InsertFileTypeContextMenuToFileTypeToEnd( GetFileType_( @ProjectSettings.FileAssociations, FileTypesNum-1 ), EntryVerb, EntryItemText, EntryCommand )
					Else
						Exit Do
					End If
				Else
					Exit Do
				End If
			Else
				Exit Do
			End If
		Else
			Exit Do
		End If
	Loop

End Sub


Sub SaveProjectSettings( _
	ByVal ProjectFile As ZString Ptr _
	)

	WritePrivateProfileString( ADDIN_NAME, "ProjectType", Str( ProjectSettings.ProjectType ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "Name", @ProjectSettings.Name, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "Version", @ProjectSettings.Version, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "VersionMajor", Str( ProjectSettings.VersionMajor ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "VersionMinor", Str( ProjectSettings.VersionMinor ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "VersionBuild", Str( ProjectSettings.VersionBuild ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "VersionRevision", Str( ProjectSettings.VersionRevision ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "Author", @ProjectSettings.Author, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "ShortName", @ProjectSettings.ShortName, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "ProjectLink", @ProjectSettings.ProjectLink, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "SupportLink", @ProjectSettings.SupportLink, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "UpdateLink", @ProjectSettings.UpdateLink, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "License", @ProjectSettings.License, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "ExecLevel", Str( ProjectSettings.ExecLevel ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "InstallFolder", @ProjectSettings.InstallFolder, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "RequireInstallFolder", @ProjectSettings.RequireInstallFolder, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "MuiOptions", Str( ProjectSettings.MuiOptions ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "WizardInstall", @ProjectSettings.WizardInstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "WizardUninstall", @ProjectSettings.WizardUninstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderInstall", @ProjectSettings.HeaderInstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderInstallRight", @ProjectSettings.HeaderInstallRight, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderUninstall", @ProjectSettings.HeaderUninstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "HeaderUninstallRight", @ProjectSettings.HeaderUninstallRight, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "IconInstall", @ProjectSettings.IconInstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "IconUninstall", @ProjectSettings.IconUninstall, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "RemDrvInst", Str( ProjectSettings.RemDrvInst ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "RemDrvInstUninst", Str( ProjectSettings.RemDrvInstUninst ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "StartMenuFolder", @ProjectSettings.StartMenuFolder, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "MainProgram", @ProjectSettings.MainProgram, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "ShortcutOptions", Str( ProjectSettings.ShortcutOptions ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "Uninstaller", @ProjectSettings.Uninstaller, ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "Compressor", Str( ProjectSettings.Compressor ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "CompressorOptions", Str( ProjectSettings.CompressorOptions ), ProjectFile )
	WritePrivateProfileString( ADDIN_NAME, "OpenWithCommand", ProjectSettings.OpenWithCommand, ProjectFile )

	Dim CurEntry As Integer

	Dim CurFolder As ProjPub_Folder Ptr = (@ProjectSettings.Folders)->Next

	Do While CurFolder <> NULL
		CurEntry += 1
		Dim CurFile As ProjPub_File Ptr = (@(CurFolder->File))->Next
		WritePrivateProfileString( ADDIN_NAME, "Files" & CurEntry, "Folder|" & *CurFolder->Name, ProjectFile )
		Do While CurFile <> NULL
			CurEntry += 1
			WritePrivateProfileString( ADDIN_NAME, "Files" & CurEntry, CurFile->Name, ProjectFile )
			CurFile = CurFile->Next
		Loop
		CurFolder = CurFolder->Next
	Loop

	WritePrivateProfileString( ADDIN_NAME, "Files" & (CurEntry + 1), NULL, ProjectFile )

	CurEntry = 0

	Dim CurFileType As ProjPub_FileType Ptr = (@ProjectSettings.FileAssociations)->Next

	Do While CurFileType <> NULL
		CurEntry += 1
		Dim CurContextMenu As ProjPub_FileTypeContextMenu Ptr = (@(CurFileType->ContextMenu))->Next
		WritePrivateProfileString( ADDIN_NAME, "FileTypes" & CurEntry, "FileType|" & *CurFileType->Ext & "|" & *CurFileType->AppIDKey & "|" & *CurFileType->Description & "|" & *CurFileType->DefaultIcon, ProjectFile )
		Do While CurContextMenu <> NULL
			CurEntry += 1
			WritePrivateProfileString( ADDIN_NAME, "FileTypes" & CurEntry, "ContextMenu|" & *CurContextMenu->Verb & "|" & *CurContextMenu->ItemText & "|" & *CurContextMenu->Command, ProjectFile )
			CurContextMenu = CurContextMenu->Next
		Loop
		CurFileType = CurFileType->Next
	Loop

	WritePrivateProfileString( ADDIN_NAME, "FileTypes" & (CurEntry + 1), NULL, ProjectFile )

End Sub


' This will load the settings from the current project file
Sub LoadProjectSettings( _
	ByVal ProjectFile As ZString Ptr _
	)

	ProjectSettings.ProjectType = GetPrivateProfileInt( ADDIN_NAME, "ProjectType", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "Name", "", @ProjectSettings.Name, MAX_PROJSETTINGS_NAME, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "Version", "", @ProjectSettings.Version, MAX_PROJSETTINGS_VERSION, ProjectFile )
	ProjectSettings.VersionMajor = GetPrivateProfileInt( ADDIN_NAME, "VersionMajor", NULL, ProjectFile )
	ProjectSettings.VersionMinor = GetPrivateProfileInt( ADDIN_NAME, "VersionMinor", NULL, ProjectFile )
	ProjectSettings.VersionBuild = GetPrivateProfileInt( ADDIN_NAME, "VersionBuild", NULL, ProjectFile )
	ProjectSettings.VersionRevision = GetPrivateProfileInt( ADDIN_NAME, "VersionRevision", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "Author", "", @ProjectSettings.Author, MAX_PROJSETTINGS_AUTHOR, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "ShortName", "", @ProjectSettings.ShortName, MAX_PROJSETTINGS_SHORTNAME, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "ProjectLink", "", @ProjectSettings.ProjectLink, MAX_PROJSETTINGS_PROJLINK, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "SupportLink", "", @ProjectSettings.SupportLink, MAX_PROJSETTINGS_SUPPLINK, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "UpdateLink", "", @ProjectSettings.UpdateLink, MAX_PROJSETTINGS_UPDATELINK, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "License", "", @ProjectSettings.License, MAX_PATH, ProjectFile )
	ProjectSettings.ExecLevel = GetPrivateProfileInt( ADDIN_NAME, "ExecLevel", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "InstallFolder", "", @ProjectSettings.InstallFolder, MAX_PROJSETTINGS_INSTFOLDER, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "RequireInstallFolder", "", @ProjectSettings.RequireInstallFolder, MAX_PATH, ProjectFile )
	ProjectSettings.MuiOptions = GetPrivateProfileInt( ADDIN_NAME, "MuiOptions", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "WizardInstall", "", @ProjectSettings.WizardInstall, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "WizardUninstall", "", @ProjectSettings.WizardUninstall, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderInstall", "", @ProjectSettings.HeaderInstall, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderInstallRight", "", @ProjectSettings.HeaderInstallRight, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderUninstall", "", @ProjectSettings.HeaderUninstall, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "HeaderUninstallRight", "", @ProjectSettings.HeaderUninstallRight, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "IconInstall", "", @ProjectSettings.IconInstall, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "IconUninstall", "", @ProjectSettings.IconUninstall, MAX_PATH, ProjectFile )
	ProjectSettings.RemDrvInst = GetPrivateProfileInt( ADDIN_NAME, "RemDrvInst", NULL, ProjectFile )
	ProjectSettings.RemDrvInstUninst = GetPrivateProfileInt( ADDIN_NAME, "RemDrvInstUninst", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "StartMenuFolder", "", @ProjectSettings.StartMenuFolder, MAX_PATH, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "MainProgram", "", @ProjectSettings.MainProgram, MAX_PATH, ProjectFile )
	ProjectSettings.ShortcutOptions = GetPrivateProfileInt( ADDIN_NAME, "ShortcutOptions", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "Uninstaller", "", @ProjectSettings.Uninstaller, MAX_PATH, ProjectFile )
	ProjectSettings.Compressor = GetPrivateProfileInt( ADDIN_NAME, "Compressor", NULL, ProjectFile )
	ProjectSettings.CompressorOptions = GetPrivateProfileInt( ADDIN_NAME, "CompressorOptions", NULL, ProjectFile )
	GetPrivateProfileString( ADDIN_NAME, "OpenWithCommand", "", @ProjectSettings.OpenWithCommand, MAX_PATH, ProjectFile )

	' Set defaults
	SetDefaultProjectSettings( ProjectFile )

End Sub

